Program Test2x2;
{$D 㭨 .. (c) 1997}
{$B-,F+,A+,N+,R-,S-,V-,I-,G+,X+,T-}

Uses Memory,Drivers,Objects,Views,Menus,App,Dialogs,MsgBox,Gadgets,
     MyTV,EnEdit,MyString,EnerDef,Diffy,Validate,MyValids,TPDate,
     Prog2x2,Def2x2,UserFunc,Calcer,MatrDef,X1,ExprComp,crt;

Type

  TEApp = object(TApplication)
    Clock:PClockView;
    Heap:PHeapView;
    ClipboardWindow:PEditWindow;
    constructor Init;
    procedure HandleEvent(var Event: TEvent); virtual;
    procedure InitMenuBar; virtual;
    procedure InitDeskTop; virtual;
    procedure InitStatusLine; virtual;
    procedure Idle;virtual;
    procedure Report;
  end;

 PRZACompilator=^TRZACompilator;
 TRZACompilator=object(T2x2Compilator)
  PasTextFiles:PCollection; {  㪠⥫ ⨯ TPascalTextFile }
  constructor Init;
  destructor Done;virtual;
 end;

 PLongint=^longint;

Var
 EApp:TEApp;
 RZAComp:PRZACompilator;

Var
 Timer:Plongint;
 Ti1,Ti2:longint;

const
  FileTypeId=opUserType1; { 䨪 ⨯ FILE }
  ComplexObjTypeId=opObjType1; { 䨪 ꥪ ⨯ complex }

Type
 TPascalTextFile=^Text;

const
 RezSwap:boolean=False;
 File2x2='test.2x2'; {  室 ணࠬ }
 File2x2out='test2x2.out'; {  䠩  뢮 १⮢ }

procedure EditProgram(Name:string; X,Y:integer; ErSt:string);
{ 뢠 ।   䠩, ⠭    (x,y)
  ᢥ稢 ᮮ饭  訡 }
var P:PEditWindow; R:TRect;
begin
 DeskTop^.GetExtent(R);
 New(P,Init(R,Name,wnNoNumber,ErSt));
 DeskTop^.Insert(P);
 If (X<>0) or (Y<>0) then P^.Editor^.SetLine(Y,X);
 P^.Editor^.SetState(sfFocused,True);
end;

constructor TEApp.Init;
var R:TRect; RezStream,M:PStream;
begin
 { 㦠  }
 RezStream:=New(PBufStream,Init('EN.RES',stOpenRead,4096));
 RezFile.Init(RezStream);
 If RezSwap then begin
  M:=New(PMemoryStream,Init(10*1024,4096));
  RezFile.SwitchTo(M,False);
  Dispose(RezStream,Done);
  RezStream:=M;
 end;
 RegisterObjects; RegisterViews; RegisterMenus; RegisterType(RStringList);
 RezStr:=PStringList(RezFile.Get('EnStrings'));

 Inherited Init;

 Desktop^.GetExtent(R);
 ClipboardWindow:=New(PEditWindow, Init(R, '', wnNoNumber,''));
 If ValidView(ClipboardWindow)<>nil then begin
  ClipboardWindow^.Hide;
  InsertWindow(ClipboardWindow);
  Clipboard:=ClipboardWindow^.Editor;
  Clipboard^.CanUndo:=False;
 end;
 {      }
 GetExtent(R); R.A.X:=R.B.X-10; R.B.Y:=R.A.Y+1;
 Clock:=New(PClockView,Init(R)); Insert(Clock);
 GetExtent(R); R.A.X:=R.B.X-8; R.A.Y:=R.B.Y-1;
 Heap:=New(PHeapView,Init(R)); Insert(Heap);
 GetExtent(R); R.A.X:=R.B.X-9; Inc(R.A.Y); R.B.Y:=R.A.Y+1;
end;

procedure TEApp.Idle;
begin
 Inherited Idle;
 Clock^.Update;
 Heap^.Update;
end;

procedure TEApp.InitDeskTop;
var R:TRect;
begin
 GetExtent(R); Inc(R.A.Y); Dec(R.B.Y);
 Desktop:=New(PIcDesktop, Init(R));
end;

procedure TEApp.InitMenuBar;
begin
 MenuBar:=PMenuBar(RezFile.Get('EnMenu'));
end;

procedure TEApp.InitStatusLine;
var R:TRect;
begin
 StatusLine:=PStatusLine(RezFile.Get('StatusLine'));
 GetExtent(R); R.A.Y:=R.B.Y-1; StatusLine^.Locate(R)
end;

const
 addedlib:boolean=False;

Procedure TEApp.Report;
{ 믮    யணࠬ }
Var Line,Col:integer; S,s1:string[80]; B:boolean; P:PCompilator;
    FC:PUserFuncCalcer; d:extended; P2x2:P2x2Library;
Begin
 Ti1:=Timer^;

 (*
 { ।⥫쭠  22- }
 If not addedlib then begin
  P2x2:=New(P2x2Library,Init('testinc.2x2'));
  P2x2^.Translate;
  b:=Manager2x2^.AddLib('testinc',P2x2);
  If b then addedlib:=True else Dispose(P2x2,Done);
 end;
 *)

 {Manager2x2^.ValidModule('TEST');
 Manager2x2^.ValidBeforeCompile('TEST');}

 {Manager2x2^.ValidModule('TESTLIB');
 Manager2x2^.ValidBeforeCompile('TESTLIB');}
 AutoUnloadLib:=True;
 New(RZAComp,Init);
 RZAComp^.Translate;
 Ti2:=Timer^;

 If RZAComp^.TransError=0 then begin
  RZAComp^.Evaluate;

  { ਬ 맮 㭪樨  22- }

  { 饬   }
  P:=PCompilator(Manager2x2^.FindLibCalcer('TESTLIB'));
  If P<>nil then begin
   { 饬 ᯮ㥬 -    }
   FC:=P^.FindExportFunc('TESTF2');
   If FC<>nil then begin
    { । 祭 - }
    d:=10; FC^.SetParValue(1,d);
    d:=50; FC^.SetParValue(2,d);
    { 塞 }
    d:=FC^.Calculate^
   end
  end;

  Dispose(RZAComp,Done);
  EditProgram(File2x2out,0,0,''); {  १ }
 end
 else begin
  Line:=RZAComp^.ErrorY; {  訡 }
  Col:=RZAComp^.ErrorX;
  { ப  ᠭ 訡 }
  S:='訡 '+Long2Str(RZAComp^.TransError)+': '+RezStr^.Get(s2x2Er+RZAComp^.TransError);
  If RZAComp^.TransError=teMethodNotDeclare then s:=s+RZAComp^.ErrorTxt;
  If RZAComp^.CompModule='MAIN' then s1:=File2x2 { 訡 -   ணࠬ }
  else
   If RZAComp^.CompModuleType=mtLibrary then { 訡 -  㫥 }
    s1:=RZAComp^.CompModule+DefLib2x2Ext
   else s1:=RZAComp^.CompModule; { 訡 -  include-䠩 }
  Dispose(RZAComp,Done);
  EditProgram(s1,Col-1,Line-1,S); {  訡 }
 end
end;

procedure TEApp.HandleEvent(var Event: TEvent);
begin
  Inherited HandleEvent(Event);
  If Event.What=evCommand then begin
   Case Event.Command of
    cm1:begin
     EditProgram(File2x2,0,0,''); exit
    end;
    cm2:Report;
    else exit;
   end;
   {Event.What:=evCommand; Event.Command:=cmMenu; PutEvent(Event);
   ClearEvent(Event);}
  end;
end;

const
 iwDate=8;
 iwTime=5;
 iwLong=9;
 iwFloat=15;
 iwText=30;

 { == ਬ⨢ 譨 㭪樨 == }

const
 EE:extended=10;
 ES:string='aaa';

Type

 PMyUserFunc=^MyUserFunc;
 MyUserFunc=object(TUserFunc)
  Par1,Par2:PFloat;
  constructor Init;
  procedure Evaluate;virtual;
  procedure AssignValue(Value:pointer);virtual;
 end;

 PStrUserFunc=^MStrUserFunc;
 MStrUserFunc=object(TUserStrFunc)
  Par1:PText;
  constructor Init;
  procedure Evaluate;virtual;
  procedure AssignValue(Value:pointer);virtual;
 end;

 PStrUserFunc1=^MStrUserFunc1;
 MStrUserFunc1=object(TUserStrFunc)
  Par1:PText;
  constructor Init;
  procedure Evaluate;virtual;
 end;

 PTestFunc1=^fTestFunc1;
 fTestFunc1=object(TUserFunc)
  Pars:array[0..2] of PFloat;
  constructor Init;
  procedure Evaluate;virtual;
 end;

Constructor MyUserFunc.Init;
Begin
 Inherited Init('FUNC01',3,[foAsProperty]);
 Par1:=InsertFloatPar(False);
 Par2:=InsertFloatPar(True);
 InsertMultiPar;
End;

Procedure MyUserFunc.Evaluate;
Var Res:extended; P:PFloat; i:integer; ArgType:TMultiExprType; AByValue:boolean;
Begin
 Res:=(Par1^+Par2^)/2-EE;
 For i:=1 to NumOfMultiArgs(3) do begin
  MultiArgDesc(3,i,ArgType,AByValue);
  If ArgType=wmpFloatMultiPar then Res:=Res+PFloat(MultiArgValue(3,i))^;
 end;
 Par2^:=-3;
 { 頥 १ }
 SetResult(@Res)
End;

Procedure MyUserFunc.AssignValue(Value:pointer);
Begin
 EE:=PFloat(Value)^+Par1^+Par2^
End;

Constructor MStrUserFunc.Init;
Begin
 Inherited Init('FUNC02',1,[foAsProperty]);
 Par1:=InsertStrPar(False);
End;

Procedure MStrUserFunc.Evaluate;
Var R:string;
Begin
 R:=Par1^+ES;
 { 頥 १ }
 SetResult(@R)
End;

Procedure MStrUserFunc.AssignValue(Value:pointer);
Begin
 ES:=PText(Value)^
End;

Constructor MStrUserFunc1.Init;
Begin
 Inherited Init('strfunc0',1,[foSimplified]);
 Par1:=InsertStrPar(False);
End;

Procedure MStrUserFunc1.Evaluate;
Var R:string;
Begin
 R:=Par1^;
 FastTrim(r);
 { 頥 १ }
 SetResult(@R)
End;

constructor fTestFunc1.Init;
var i:integer;
begin
 Inherited Init('testfunc1',3,[foAsProperty]);
 for i:=0 to 2 do Pars[i]:=InsertFloatPar(True);
 SetMinArgCount(1)
end;

procedure fTestFunc1.Evaluate;
var r:extended; i:integer;
begin
 r:=0;
 for i:=0 to FactArgCount-1 do r:=r+PFloat(Pars[i])^;
 r:=FactArgCount*r;
 SetResult(@R)
end;

Type

 { === 㭪:    ﬨ , ࠧ  
   ᯮ  ࠨ ⮬᪨ ==== }

 PfInput=^fInput;
 fInput=object(TUserFunc)
  { ⨯ , 蠯 , 祭  }
  PMWhats,PMTitles,PMValues:Ppointer;
  Count:PFloat; { ᫮  }
  Title:PText; {   }
  constructor Init;
  procedure Evaluate;virtual;
 end;

 PKDialog=^TKDialog;
 TKDialog=object(TDialog)
  procedure HandleEvent(var Event: TEvent); virtual;
 end;

 PDInp=^TDInp;
 TDInp=object(TKDialog)
  IL:array[1..15] of PInputLine;
  Wh:array[1..15] of word;
  Values:PStrMatrix;
  Count:word;
  constructor Init(Bounds:TRect; ACount:word; const Ttl:string;
   TMaxLen,DMaxLen:byte;
   AWhats:PMatrix; ATitles,AValues:PStrMatrix);
  function Valid(Command:Word):boolean; virtual;
  function Translate(Var Y:integer):boolean;
 end;

Procedure TKDialog.HandleEvent(Var Event:TEvent);
Begin
 Inherited HandleEvent(event);
 If Event.What=evKeyDown then
  If Phase=phPostProcess then
   Case event.keycode of
    kbLeft,kbUp: begin
     ClearEvent(Event); SelectNext(True); exit
    end;
    kbdown,kbright: begin
     ClearEvent(Event);
     If Current^.Valid(cmNext) then SelectNext(False); exit
    end;
    else exit
   end;
End;

Constructor fInput.Init;
Begin
 Inherited Init('INPUT',5,[]);
 Title:=InsertStrPar(False);
 Count:=InsertFloatPar(False);
 PMWhats:=InsertArrayPar;
 PMTitles:=InsertStrArrayPar;
 PMValues:=InsertStrArrayPar;
End;

Procedure fInput.Evaluate;
Var Cnt,W,W1,W2,I,K:word; Ttl:string; P:PDInp; R:TRect; Res:extended;
    S:string; Titles,Values:PStrMatrix; Whats:PMatrix; Sp:pointer;
Begin
 Res:=1;
 SetResult(@Res);

 Cnt:=Round(Count^);
 If (Cnt>0) and (Cnt<=15) then begin
  Ttl:=Title^;
  W:=MinI(10+byte(Ttl[0]),80); { ਭ    Title }

  Titles:=PStrMatrix(PMTitles^);
  Values:=PStrMatrix(PMValues^);
  Whats:=PMatrix(PMWhats^);

  W1:=0; W2:=0;
  For I:=1 to Cnt do begin
   Sp:=Titles^.Get(I);
   If byte(Sp^)>20 then byte(Sp^):=20;
   If byte(Sp^)>W1 then W1:=byte(Sp^); { max ਭ  }

   K:=Round(extended(Whats^.Get(I)^));
   Case K of { max ਭ   }
    iwDate,iwTime,iwLong,iwFloat,iwText: W2:=MaxI(W2,K)
    else exit
   end;
  end;

  Inc(W2,2); K:=2+W1+2+W2+2; K:=MaxI(K,W);

  R.Assign(0,0,K,Cnt+4);
  New(P,Init(R,Cnt,Ttl,W1,W2,Whats,Titles,Values));
  K:=DeskTop^.ExecView(P); Dispose(P,Done);
  If K=cmOK then Res:=0
 end;
 SetResult(@Res);
End;

Constructor TDInp.Init(Bounds:TRect; ACount:word; const Ttl:string;
   TMaxLen,DMaxLen:byte; AWhats:PMatrix; ATitles,AValues:PStrMatrix);
Var S:string; I,K,Y:word; V:PValidator;
Begin
 Inherited Init(Bounds,Ttl);
 Options:=Options or ofCentered;

 Count:=ACount; Values:=AValues;
 Y:=2;

 For I:=1 to ACount do begin
  S:=PString(ATitles^.Get(I))^;
  K:=Round(extended(AWhats^.Get(I)^));
  Wh[I]:=K;

  Case K of
   iwDate: V:=New(PPXPictureValidator,Init('##/[##/[##]]',True));
   iwTime: V:=New(PPXPictureValidator,Init('##/##]',True));
   iwLong: V:=New(PFilterValidator,Init(['0'..'9','-']));
   iwFloat:V:=New(PFloatValidator,Init(-1e-10,1e10));
   iwText: V:=nil;
  end;

  Bounds.Assign(TMaxLen+4,Y,TMaxLen+K+6,Y+1);
  IL[I]:=New(PInputLine,Init(Bounds,K));
  With IL[I]^ do begin
   Options:=Options or ofValidate; Validator:=V;
   SetData(AValues^.Get(I)^);
  end;
  Insert(IL[I]);

  Bounds.Assign(1,Y,2+TMaxLen,Y+1);
  Insert(New(PLabel,Init(Bounds,S,IL[I])));
  Inc(Y)
 end;
 SelectNext(False);
End;

Function TDInp.Translate(Var Y:integer):boolean;

 Function GetTime(Var St:string; Var T:word):boolean;
 Var I1,I2:byte; cod:integer;
 Begin
  GetTime:=False;
  Val(Copy(St,1,2),I1,cod);
  If (I1>24) then exit;
  Val(Copy(St,4,2),I2,cod);
  If I2>60 then exit;
  T:=I2 or (I1 shl 8);
  GetTime:=True
 end;

 Function GetDate(Var St:string; Var RD:RDate):boolean;
 Var I1,I2:byte; cod:integer; S:string[20]; Len:byte absolute S;
 Begin
  S:=St;
  With RD do begin
   If S[Len]='/' then Dec(byte(S[0]));
   I1:=CharPos('/',S);
   I2:=LastCharPos('/',S);
   If I1<>I2 then begin { 뤥塞  }
    Val(Copy(S,1,2),D,cod);
    System.Delete(S,1,3)
   end;
   If I1<>0 then begin { 뤥塞  }
    Val(Copy(S,1,2),M,cod);
    System.Delete(S,1,3)
   end;
   Val(S,Y,cod);
   If ((I1=0) or (I1=I2)) and (D<>1) then D:=DaysInMonth(M,Y+1900)
   else
    If D>DaysInMonth(M,Y+1900) then D:=DaysInMonth(M,Y+1900)
  end;
 end;

Var S:string[50]; RD:RDate; T,I:word; D:Date;
Begin
 Translate:=False;
 For I:=1 to Count do begin
  Y:=I;
  IL[I]^.GetData(S);
  FastTrim(S);
  If (S='') and (Wh[I]<>iwText) then exit;

  Case Wh[I] of
   iwDate: begin
    With RD do begin D:=1; M:=1; end;
    GetDate(S,RD);
    D:=DMYtoDate(RD.D,RD.M,RD.Y);
    S:=DateToDateString('dd/mm/yy',D);
   end;
   iwTime: begin
    If not GetTime(S,T) then exit;
   end;
   iwLong,iwFloat,iwText:;
  end;
  Values^.Put(I,@S)
 end;
 Translate:=True;
End;

Function TDInp.Valid(Command:word):boolean;
Var B:boolean; Y:integer;
Begin
 Valid:=True;
 If Command=cmOK then begin
  Valid:=False;
  B:=Inherited Valid(cmOK);
  If B then begin
   B:=Translate(Y);
   If not B then IL[Y]^.Select else Valid:=True
  end
 end
End;

Type

 PfSplitAr=^fSplitAr;
 fSplitAr=object(TUserProc)
  PM:Ppointer;
  ACount,MaxLen,NewCount:PFloat;
  constructor Init;
  procedure Evaluate;virtual;
 end;

 PfMessage=^fPMessage;
 fPMessage=object(TUserProc)
  D1:PText;                    { MsgBox(string) }
  constructor Init;
  procedure Evaluate;virtual;
 end;

 PfGetDateTime=^fGetDateTime;
 fGetDateTime=object(TUserFunc)
  What:byte;
  constructor Init(AWhat:byte);     { Today/CurTime      }
  procedure Evaluate;virtual;
 end;

 PfDateToDMY=^fDateToDMY;
 fDateToDMY=object(TUserProc)      { DateToDMY(D:Date; Var d,m,y:word) }
  D1,D2,D3,D4:PFloat;
  constructor Init;
  procedure Evaluate;virtual;
 end;

 PfDMYToDate=^fDMYToDate;
 fDMYToDate=object(TUserFunc)      { Date=DMYToDate(d,m,y:word) }
  D1,D2,D3:PFloat;                 { word=ValidDate(d,m,y:word) }
  What:byte;
  constructor Init(AWhat:byte);
  procedure Evaluate;virtual;
 end;

 PfMenu=^fMenu;
 fMenu=object(TUserFunc)
  PM:Ppointer;                     { word=Menu(array of str,word)     }
  N:PFloat;
  constructor Init;
  procedure Evaluate;virtual;
 end;

Constructor fPMessage.Init;
Var S:string[15];
Begin
 S:='MESSAGE';
 Inherited Init(S,1);
 D1:=InsertStrPar(False);
End;

Procedure fPMessage.Evaluate;
Begin
 MessageBox(Pstring(D1)^,nil,mfOKButton+mfInformation)
End;

Constructor fSplitAr.Init;
Begin
 Inherited Init('SPLITAR',4);
 PM:=InsertStrArrayPar;
 ACount:=InsertFloatPar(False);
 MaxLen:=InsertFloatPar(False);
 NewCount:=InsertFloatPar(True);
End;

Procedure fSplitAr.Evaluate;
Var M:PStrMatrix; k,AC,NC,Sz,Cn,I,ML,J:word; S,St,S1:string;
    NAr:array[1..30] of string; Per:byte; B:boolean;
Begin
 M:=PStrMatrix(PM^);
 Sz:=M^.Lines;
 AC:=Round(ACount^);
 ML:=Round(MaxLen^);
 I:=1; J:=0; St:='';

 While (I<=AC) do begin
   S:=PString(M^.Get(I))^;

   While True do begin
    Repeat
     B:=SplitString(S,St,ML,Per);
     If B and (I<AC) then begin
      Inc(I);
      S1:=PString(M^.Get(I))^;
      FastTrimHead(S1);
      S:=S+' '+S1;
     end
     else B:=False;
    until not B;
    Inc(J);
    NAr[J]:=RPad(S,ML);
    If St='' then break else S:=St
   end;
   Inc(I);
 end;

 k:=M^.StrLen-1;
 If k<ML then k:=ML;
 If (J>Sz) or (M^.StrLen-1<ML) then M^.Newsize(MaxI(J,Sz),k);{ J:=Sz;}
 S:=FillStr(' ',ML);
 For I:=J+1 to Sz do NAr[I]:=S;
 For I:=1 to J do M^.Put(I,@NAr[I]);

 NewCount^:=J;
End;

Constructor fGetDateTime.Init(AWhat:byte);
Const Ns:array[1..2] of string[8]=('TODAY','CURTIME');
Begin
 Inherited Init(Ns[AWhat],0,[]);
 What:=AWhat
End;

Procedure fGetDateTime.Evaluate;
Var Res:extended; B:boolean; D:Date; Hours:word;
Begin
  Case What of
   1:begin D:=Today; Res:=word(D); end;
   2:begin
      asm
       mov ah,2ch
       int 21h
       mov Hours,cx
      end;
      Res:=Hours
     end
  end;
 SetResult(@Res)
End;

Constructor fDateToDMY.Init;
Begin
 Inherited Init('DATETODMY',4);
 D1:=InsertFloatPar(False); D2:=InsertFloatPar(True);
 D3:=InsertFloatPar(True); D4:=InsertFloatPar(True);
End;

Procedure fDateToDMY.Evaluate;
Var D:word; Day,M,Y:integer;
Begin
 D:=Round(D1^);
 DateToDMY(D,Day,M,Y);
 D2^:=Day; D3^:=M; D4^:=Y
End;

Constructor fDMYToDate.Init(AWhat:byte);
Var S:string[10];
Begin
 If AWhat=1 then S:='DMYTODATE' else S:='VALIDDATE';
 Inherited Init(S,3,[foSimplified]);
 D1:=InsertFloatPar(False); D2:=InsertFloatPar(False);
 D3:=InsertFloatPar(False);
 What:=AWhat
End;

Procedure fDMYToDate.Evaluate;
Var D:word; Res:extended;
Begin
 Case What of
  1: D:=DMYToDate(Round(D1^),Round(D2^),Round(D3^));
  2: D:=byte(ValidDate(Round(D1^),Round(D2^),Round(D3^)));
 end;
 Res:=D;
 SetResult(@Res)
End;

Function PopupMenu(PoPMenu:PMenuBox):word;
Var X,Y:integer;
Begin
 X:=PopMenu^.Origin.X;
 If X+PopMenu^.Size.X>Desktop^.Size.X then X:=Desktop^.Size.X-PopMenu^.Size.X;
 Y:=PopMenu^.Origin.Y;
 If Y+PopMenu^.Size.Y>Desktop^.Size.Y then Y:=Desktop^.Size.Y-PopMenu^.Size.Y;
 If X<0 then X:=0;
 If Y<0 then Y:=0;
 PopMenu^.MoveTo(X,Y);
 PopupMenu:=Desktop^.ExecView(PopMenu)
End;

Constructor fMenu.Init;
Var S:string[8];
Begin
 S:='MENU';
 Inherited Init(S,2,[]);
 PM:=InsertStrArrayPar;
 N:=InsertFloatPar(False);
End;

Procedure fMenu.Evaluate;
Var Res:extended; I,K,Cm,MLen,L:word; Er,X0,Y0:integer; S:string[50]; R:TRect;
    M:PStrMatrix; MB:PMenuBox; P,Q:PMenuItem;
Begin
 M:=PStrMatrix(PM^);

 While True do begin
  Res:=0; MLen:=0;
  K:=Round(N^);
  If K>23 then K:=23 else If K<2 then break;
  P:=NewItem(Pstring(M^.Get(K))^,'',0,8000+K,0,nil);

  For I:=K-1 downto 1 do begin
   S:=Pstring(M^.Get(I))^;
   MLen:=MaxI(MLen,byte(S[0]));
   Q:=NewItem(S,'',0,8000+I,0,P);
   P:=Q
  end;

  X0:=(ScreenWidth-MLen) div 2;
  Y0:=(ScreenHeight-K) div 2;
  R.Assign(X0,Y0,X0+MLen,X0+K);
  MB:=New(PMenuBox,Init(R,NewMenu(P),nil));
  Cm:=PopupMenu(MB);
  DisposeMenu(MB^.Menu); Dispose(MB,Done);
  If Cm>0 then Dec(Cm,8000);
  Res:=Cm;
  break
 end;
 SetResult(@Res)
End;

Type

PAssignFile=^ TAssignFile;
TAssignFile =object(TUserProc)
  TFile: PFloat; {  㯠  㬥 TextFile }
  FName: PText; {  㯠  㬥 FileName }
  constructor Init;
  procedure Evaluate;virtual;
end;

POpenFile=^ TOpenFile;
TOpenFile =object(TUserFunc)
  TFile: PFloat; {  㯠  㬥 TextFile }
  FMode: PFloat;
  constructor Init;
  procedure Evaluate;virtual;
end;

PCloseFile=^ TCloseFile;
TCloseFile =object(TUserProc)
  TFile: PFloat; {  㯠  㬥 TextFile }
  constructor Init;
  procedure Evaluate;virtual;
end;

PReadWriteFile=^ TReadWriteFile;
TReadWriteFile =object(TUserFunc)
  TFile: PFloat; {  㯠  㬥 TextFile }
  Data: PText;
  What:integer;
  constructor Init(AWhat: integer);
  procedure Evaluate;virtual;
end;

PEOFFile=^ TEOFFile;
TEOFFile =object(TUserFunc)
  TFile: PFloat; {  㯠  㬥 TextFile }
  constructor Init;
  procedure Evaluate;virtual;
end;

 PfSumObj=^fSumObj;
 fSumObj=object(TUserFunc)
  procedure Evaluate;virtual;
 end;

 PfSumObj1=^fSumObj1;
 fSumObj1=object(TUserFunc)
  procedure Evaluate;virtual;
 end;

 PfStrObj=^fStrObj;
 fStrObj=object(TUserStrFunc)
  procedure AssignValue(Value:pointer);virtual;
  procedure Evaluate;virtual;
 end;

 PfStrObj1=^fStrObj1;
 fStrObj1=object(TUserStrFunc)
  procedure Evaluate;virtual;
  procedure AssignValue(Value:pointer);virtual;
 end;

 PfEqualObj=^fEqualObj;
 fEqualObj=object(TUserFunc)
  Obj1,Obj2:Ppointer;
  constructor Init;
  procedure Evaluate;virtual;
 end;

procedure fSumObj.Evaluate;
var p:PUserObject; r,re,im:float;
begin
 p:=PUserObject(GetSelfObject);
 p^.GetField(1,im);
 p^.GetField(2,re);
 r:=im+re;
 SetResult(@r)
end;

procedure fSumObj1.Evaluate;
var p:PUserObject; r,re,im:float;
begin
 p:=PUserObject(GetSelfObject);
 p^.GetField(1,im);
 p^.GetField(2,re);
 r:=(im+re)*2;
 SetResult(@r)
end;

procedure fStrObj.Evaluate;
var s:string;
begin
 {s:='oleg';}
 PUserObject(GetSelfObject)^.GetField(4,s);
 SetResult(@s)
end;

procedure fStrObj.AssignValue(Value:pointer);
begin
 PUserObject(GetSelfObject)^.PutRawField(4,PText(Value))
end;

procedure fStrObj1.Evaluate;
var s:string;
begin
 s:='bunin';
 SetResult(@s)
end;

procedure fStrObj1.AssignValue(Value:pointer);
var s:string;
begin
 s:=PText(Value)^+'...';
 PUserObject(GetSelfObject)^.PutRawField(4,@s)
end;

constructor fEqualObj.Init;
begin
 Inherited Init('OBJEQUAL',2,[]);
 Obj1:=InsertAnyObjectPar;
 Obj2:=InsertAnyObjectPar;
end;

procedure fEqualObj.Evaluate;
var r:extended;
begin
 If Obj1^=Obj2^ then r:=1 else r:=0;
 SetResult(@r)
end;

constructor TAssignFile.Init;
begin
 Inherited Init('ASSIGNFILE',2);
 { 塞 ࠬ ⨯ File}
 TFile:=InsertUserTypePar(FileTypeId, True); {  뫪 }
 { 塞 ࠬ ⨯ string}
 FName:=InsertStrPar(False);
end;

procedure TAssignFile.Evaluate;
var P: TPascalTextFile; { 䠩 ६  맮 㭪権 Pascal }
begin
  New(P);
  RZAComp^.PasTextFiles^.Insert(P);
 { TFile 䨧᪨ ࠪ㥬  㪠⥫  ६ ᪠᪮ ⨯ Text }
  TFile^:= longint(P); { 頥 䠩 ६ }
  System.Assign(P^, FName^);
end;

constructor TOpenFile.Init;
begin
  Inherited Init('OPENFILE',2,[]);
  { 塞 ࠬ ⨯ File}
  TFile:=InsertUserTypePar(FileTypeId, False);
  FMode:=InsertFloatPar(False);
end;

procedure TOpenFile.Evaluate;
var r:extended; P: TPascalTextFile;
begin
 P:= TPascalTextFile(pointer(Round(TFile^)));
 If P=nil then r:=-1  {  뫠 믮 楤 AssignFile }
 else begin
  If FMode^=1 then System.Rewrite(P^) else System.Reset(P^);
  If IOResult=0 then r:=0 else r:=1
 end;
 SetResult(@ r)
end;

constructor TCloseFile.Init;
begin
 Inherited Init('CLOSEFILE',1);
 { 塞 ࠬ ⨯ File}
 TFile:=InsertUserTypePar(FileTypeId, True); {  뫪 }
end;

procedure TCloseFile.Evaluate;
var P: TPascalTextFile;
begin
 P:= TPascalTextFile(pointer(Round(TFile^)));
 If P<>nil then begin
  System.Close(P^);
  RZAComp^.PasTextFiles^.Delete(P);
  Dispose(P)
 end;
 TFile^:= 0
end;

constructor TReadWriteFile.Init(AWhat:integer);
const
 Names:array[0..1] of string[9]=('READFILE','WRITEFILE');
 ParVars: array[0..1] of integer=(1,0);
begin
  Inherited Init(Names[AWhat], 2, []);
  { 塞 ࠬ ⨯ File}
  TFile:=InsertUserTypePar(FileTypeId, False);
  Data:=InsertStrPar(AWhat=0);
  What:=AWhat
end;

procedure TReadWriteFile.Evaluate;
var r:extended; P: TPascalTextFile;
begin
 P:= TPascalTextFile(pointer(Round(TFile^)));
 If P=nil then r:=-1  {  뫠 믮 楤 AssignFile }
 else begin
  If What=0 then System.Readln(P^, Data^) else System.Writeln(P^, Data^);
  If IOResult=0 then r:=0 else r:=1
 end;
 SetResult(@ r)
end;

constructor TEOFFile.Init;
begin
  Inherited Init('EOFFILE', 1,[]);
  { 塞 ࠬ ⨯ File}
  TFile:=InsertUserTypePar(FileTypeId, False);
end;

procedure TEOFFile.Evaluate;
var r:extended; P: TPascalTextFile;
begin
 P:= TPascalTextFile(pointer(Round(TFile^)));
 If P=nil then r:=-1  {  뫠 믮 楤 AssignFile }
 else
  If System.EOF(P^)  then  r:=1 else r:=0;
 SetResult(@r)
end;

function EofFiles(p:TPascalTextFile):extended;
var r:extended;
begin
 If P=nil then r:=-1  {  뫠 믮 楤 AssignFile }
 else
  If System.EOF(P^)  then  r:=1 else r:=0;
 EofFiles:=r
end;

function My(var l:longint):longint{double};
begin
 My:=l div 2;
 l:=1
end;

function My1(var s:string):string{double};
begin
 My1:=s+'00';
 s:='123'
end;

function My2(var e:double):double;
begin
 My2:=e/2;
 e:=13
end;

function WhatArray(a:PMatrix):string;
begin
 case a^.GetMatrixType of
  GeneralM,SimmM,DiagM: WhatArray:='᫮';
  StringM: WhatArray:='ப';
  else WhatArray:=''
 end
end;

function Add2Obj(o1,o2:PUserObject):double;
var r:double;
begin
 r:=PFloat(o1^.GetRawField(2))^;
 r:=r+PFloat(o2^.GetRawField(2))^;
 Add2Obj:=r
end;

procedure AddNewFuncDefs;assembler;
asm
 dw wcFunc              { func/proc }
 db 8,'LPOPOLAM'        {  ,  }
 dw 1                   { - - }
 dw dctFloat; db pptLong,0  { ⨯ 22, ⨯ Pascal, 0/1 - 뫪/ 祭 }
 dw rtFloat,prtLong     { 頥 ⨯ 22, 頥 ⨯ Pascal }
 dw SEG My, OFFSET My   {  -/楤 }
 db 0                   { 1 = - / 饭 ᫨  䠪.- - ⠭ }

 dw wcFunc
 db 5,'SPLUS'
 dw 1
 dw dctString; db pptString,0
 dw rtString,prtString
 dw SEG My1, OFFSET My1
 db 0

 dw wcFunc
 db 4,'MY2F'
 dw 1
 dw dctFloat; db pptDouble,0
 dw rtFloat,prtDouble
 dw SEG My2, OFFSET My2
 db 0

 dw wcFunc
 db 9,'WHATARRAY'
 dw 1
 dw dctAnyArray; db pptArray,1
 dw rtString,prtString
 dw SEG WhatArray, OFFSET WhatArray
 db 0

 dw wcFunc
 db 7,'EOFFILE'
 dw 1
 dw FileTypeId; db pptPointer,1
 dw rtFloat,prtExtended
 dw SEG EofFiles, OFFSET EofFiles
 db 0

 dw wcFunc
 db 10,'ADD2OBJECT'
 dw 2
 dw ComplexObjTypeId; db pptObject,1
 dw ComplexObjTypeId; db pptObject,1
 dw rtFloat,prtDouble
 dw SEG Add2Obj, OFFSET Add2Obj
 db 0
end;


const
 EnvObjId= opObjType1+10; { 䨪樮  ⨯ ꥪ }

var
  FUserName:string[20]; {  ⮩ ६ Pascal-ணࠬ ࠭  짮⥫ }

Type
  { 㭪 짮⥫  㯠   짮⥫ }
  PUseNameFunc=^ TUseNameFunc;
  TUseNameFunc=object(TUserStrFunc)
     procedure Evaluate; virtual;
  end;

procedure TUseNameFunc.Evaluate;
begin
  SetResult(@FUserName)
end;

{
Type
   PMyUserObject=^TMyUserObject;
   TMyUserObject=object(TUserObject)
      PrivateStr:string[10]
   end;

procedure TUseNameFunc.Evaluate;
var s: string;
begin
  s:= UserName+ PMyUserObject(GetSelfObject)^.PrivateStr;
  SetResult(@s)
end;

function CreateMyObj(Obj2x2: P2x2Object): PUserObject;
var P: PMyUserObject;
begin
  P:=New(PMyUserObject, Init(Obj2x2));
  CreateMyObj:= PUserObject(P)
end;

EnvObjDef^.SetOnCreate(CreateMyObject);
}

procedure ObjOp(Par1,Par2,Res:PUserObject; AOperator:TMOOperations);
var im1,re1,im2,re2,resim,resre:extended;
begin
 case AOperator of
  moPlus: begin
   resim:=PFloat(Par1^.GetRawField(1))^+PFloat(Par2^.GetRawField(1))^;
   resre:=PFloat(Par1^.GetRawField(2))^+PFloat(Par2^.GetRawField(2))^;
   Res^.PutField(1,resim);
   Res^.PutField(2,resre);
  end;
 end
end;

const
 EqId= opObjType1+20; { 䨪樮   TEquation }
 EqId1= opObjType1+21; { 䨪樮   LinEquation }
 EqId2= opObjType1+22; { 䨪樮   BiEquation }

Type

  PRootCntFunc =^ TRootCntFunc;
  TRootCntFunc =object(TUserFunc)
     procedure Evaluate; virtual;
  end;

  PRootFunc =^ TRootFunc;
  TRootFunc =object(TUserFunc)
     procedure Evaluate; virtual;
  end;

  PEvaluateFunc =^ TEvaluateFunc;  { ࠪ ⥫ ࠢ }
  TEvaluateFunc =object(TUserProc)
     procedure Evaluate; virtual;
  end;

  PEvaluate1Func =^ TEvaluate1Func; { ⥫ ࠢ 1- ⥯ }
  TEvaluate1Func =object(TUserProc)
     procedure Evaluate; virtual;
  end;

  PEvaluate2Func =^ TEvaluate2Func; { ⥫ ࠢ 2- ⥯ }
  TEvaluate2Func =object(TUserProc)
     procedure Evaluate; virtual;
  end;

  PCreateFunc =^ TCreateFunc;
  TCreateFunc =object(TUserProc)
     procedure Evaluate; virtual;
  end;

var
 EqDef:P2x2Object; { ⥫ ⨯ ꥪ }
 RootCntFunc,RootFunc:PUserFunc;
 CreateFunc:PUserProc;

procedure TCreateFunc.Evaluate;
var P:PUserObject; i:Float;
begin
 P:=GetSelfObject; { 뫪   ꥪ }
 { । ⥯ ࠢ }
 case P^.GetObjDef^.ObjId of
  EqId1: i:=1;
  EqId2: i:=2
  else i:=0
 end;
 P^.PutField(1,i); { 樠㥬 ⥯ ࠢ Power }
end;

procedure EvaluateFuncEval(Func:PFuncObject);
var RCnt:Float; P:PUserObject;
begin
 with PUserProc(Func)^ do begin
  { 稬 뫪   ꥪ }
  P:=GetSelfObject;
  RCnt:=0;
  P^.PutField(2,RCnt); { । 祭  TEquation.FRootCount }
 end
end;

procedure TEvaluateFunc.Evaluate;
var RCnt:Float; P:PUserObject;
begin
 { 稬 뫪   ꥪ }
 P:=GetSelfObject;
 RCnt:=0;
 P^.PutField(2,RCnt); { । 祭  TEquation.FRootCount }
end;

procedure TEvaluate1Func.Evaluate;
var RCnt,Root1:Float; P:PUserObject; a,b:Float;
begin
 { 稬 뫪   ꥪ }
 P:=GetSelfObject;
 RCnt:=1; {  ७ }
 with P^ do begin
  GetField(3,a);
  GetField(4,b);
  Root1:=-b/a;
 end;
 P^.PutField(2,RCnt); { । 祭  TEquation.FRootCount }
 P^.PutField(5,Root1); { 1- ७ }
end;

procedure TEvaluate2Func.Evaluate;
var RCnt,Root1,Root2:Float; P:PUserObject; a,b,c,D:Float;
begin
 { 稬 뫪   ꥪ }
 P:=GetSelfObject;
 with P^ do begin
  GetField(3, a);
  GetField(4, b);
  GetField(6, c);
  D:=b*b-4*a*c;
  If D< 0 then RCnt:=0 { ୥  }
  else
   If D=0 then begin { ७  }
    RCnt:=1;
    Root1:=-b/(2*a)
   end
   else begin
    RCnt:=2;
    D:=Sqrt(D);
    Root1:=(-b+D)/(2*a); Root2:=(-b-D)/(2*a)
   end
 end;
 P^.PutField(2,RCnt); { । 祭  TEquation.FRootCount }
 If RCnt>0 then P^.PutField(5,Root1); { 1- ७ }
 If RCnt>1 then P^.PutField(7,Root2); { 2- ७ }
end;

procedure TRootCntFunc.Evaluate;
var RCnt:Float; P:PUserObject;
begin
 { 稬 뫪   ꥪ }
 P:=GetSelfObject;
 P^.GetField(2,RCnt); { 稬 祭 ਢ⭮  FRootCount }
 SetResult(@RCnt)
end;

procedure TRootFunc.Evaluate;
var RCnt,Root,N:Float; P:PUserObject;
begin
 { 稬 뫪   ꥪ }
 P:=GetSelfObject;
 P^.GetField(2,RCnt); { 稬 祭 ਢ⭮  FRootCount }
 GetParValue(1,N); { 稬 祭 ࠬ ⮤ - #  }
 If (N<1) or (N>RCnt) then Root:=0
 else
  If N=1 then P^.GetField(5,Root) else P^.GetField(7,Root);
 SetResult(@Root)
end;

Procedure AddTerms(P:P2x2Storage);
Const
 Sh2:array[1..5] of string[7]=('IWDATE','IWTIME','IWLONG','IWREAL','IWTEXT');
 Sh2V:array[1..5] of word=(8,5,9,15,30);
Var Fir,i:integer; Funcs:array[1..20] of PCalcer; b:boolean;
    F1:PMyUserFunc; F2:PStrUserFunc; F3:PStrUserFunc1; F4:PTestFunc1;
    Pars:TDirectCallPars; UO,UO1:P2x2Object; TmpFloat:extended;
    EnvObjDef: P2x2Object; { ⥫ ⨯ ꥪ }
    EnvObj: PUserObject; {  ६-ꥪ }
    Q:PUserProc;
begin
 Fir:=0;
 UO:=New(P2x2Object,Init('COMPLEX',ComplexObjTypeId,nil));
 with UO^ do begin
  b:=AddField('IM',dctFloat,[]);
  b:=AddField('RE',dctFloat,[]);
  b:=AddField('AR',dctArray,[]);
  b:=AddField('S',dctString,[]);
  b:=AddObjectRefField('OBJ',User2x2TObject,[]);
  DefineArray(FindField('AR'),2,2);
  i:=AddMethod(New(PfSumObj,Init('SUM',0,[])),[offVirtual]);
  i:=AddMethod(New(PfStrObj,Init('NAME',0,[foAsProperty])),[offVirtual]);
  EnableOperator([moPlus]);
  SetOnCalcOperator(ObjOp);
 end;
 b:=P^.AddUserObjType(UO);

 UO1:=New(P2x2Object,Init('COMPLEX1',ComplexObjTypeId+1,UO));
 with UO1^ do begin
  i:=AddMethod(New(PfSumObj1,Init('SUM',0,[])),[offVirtual]);
  i:=AddMethod(New(PfStrObj1,Init('NAME',0,[foAsProperty])),[offVirtual]);
  EnableOperator([moPlus]);
 end;
 b:=P^.AddUserObjType(UO1);

 EnvObjDef:=New(P2x2Object, Init('',EnvObjId,nil));
 b:=EnvObjDef^.AddField('OSVERSION', dctFloat,[offReadOnly]);
 i:=EnvObjDef^.AddMethod(New(PUseNameFunc, Init('USERNAME',0,[foSimplified])),[offReadOnly]);
 b:=Manager2x2^.AddUserObjType(EnvObjDef);

 EnvObj:= New(PUserObject, Init(EnvObjDef));
 b:=Manager2x2^.AddUserObjVar('ENVIRONMENT', EnvObj);
 TmpFloat:=3;
 EnvObj^.PutField(1,TmpFloat);
 FUserName:='oleg bunin';

{ ᮧ ⮤ }
  RootCntFunc:=New(PRootCntFunc, Init('ROOTCOUNT',0,[] ));
  RootFunc:= New(PRootFunc, Init('ROOT',1,[] ));
  RootFunc^.InsertFloatPar(False);
  CreateFunc:= New(PCreateFunc, Init('CREATE',0));

  { ᮧ ⥫ ࠪ⭮ ᫨⥫ ࠢ }
  EqDef:=New(P2x2Object, Init('TEQUATION', EqId,nil));

  { 塞  }
  b:=EqDef^.AddField('POWER', dctFloat, [offReadOnly]);
  b:=EqDef^.AddField('FROOTCOUNT', dctFloat, [offProtected]);

  { 塞 ⮤ }
  i:=EqDef^.AddMethod(CreateFunc, [offVirtual]);
  Q:=New(PUserProc,Init('EVALUATE',0));
  Q^.SetOnEvaluate(EvaluateFuncEval);
  {i:=EqDef^.AddMethod(New(PEvaluateFunc, Init('EVALUATE',0)), [offVirtual] );}
  i:=EqDef^.AddMethod(Q, [offVirtual]);
  i:=EqDef^.AddMethod(RootCntFunc, []);
  i:=EqDef^.AddMethod(RootFunc, []);

  { ॣ㥬 ⨯ ꥪ }
  b:=P^.AddUserObjType(EqDef);

  { ᮧ ⥫ ᫨⥫ ࠢ 1- ⥯ }
  EqDef:=New(P2x2Object, Init('LINEQUATION', EqId1,EqDef));
  {  ᫮   ࠭ 樥⮢ ࠢ }
  b:=EqDef^.AddField('A', dctFloat,[]);
  b:=EqDef^.AddField('B', dctFloat,[]);
  b:=EqDef^.AddField('FROOT1', dctFloat,[offProtected]);
  { 塞 㠫 ⮤ }
  i:=EqDef^.AddMethod(New(PEvaluate1Func, Init('EVALUATE',0)), [offVirtual] );
  { ॣ㥬 ⨯ ꥪ }
  b:=P^.AddUserObjType(EqDef);

  { ᮧ ⥫ ᫨⥫ ࠢ 2- ⥯ }
  EqDef:=New(P2x2Object, Init('BIEQUATION', EqId2,EqDef));
  {  ᫮   ࠭ 3- 樥 ࠢ }
  b:=EqDef^.AddField('C', dctFloat,[]);
  b:=EqDef^.AddField('FROOT2', dctFloat,[offProtected]);
  { 塞 㠫 ⮤ }
  i:=EqDef^.AddMethod(New(PEvaluate2Func, Init('EVALUATE',0)), [offVirtual] );
  { ॣ㥬 ⨯ ꥪ }
  b:=P^.AddUserObjType(EqDef);

 with P^ do begin
 { 騥 - }
 Funcs[1]:=New(PfSplitAr,Init);
 Funcs[2]:=New(PfInput,Init);
 Funcs[3]:=New(PfGetDateTime,Init(1));  { Today }
 Funcs[4]:=New(PfGetDateTime,Init(2));  { CurTime }
 Funcs[5]:=New(PfDateToDMY,Init);
 Funcs[6]:=New(PfDMYToDate,Init(1));    { DMYToDate }
 Funcs[7]:=New(PfDMYToDate,Init(2));    { ValidDate }
 Funcs[8]:=New(PfMessage,Init);         { Meassage }
 Funcs[9]:=New(PfMenu,Init);            { Menu     }
 New(F1,Init);
 New(F2,Init);
 New(F3,Init);
 New(F4,Init);

 For I:=1 to 5 do AddUserConst(Sh2[I],Sh2V[I]);
 AddUserConst('Pipopolam',Pi/2);
 AddUserType('POINTER',FileTypeId);

 { 塞 ࠧ 6 㭪樨 אַ 맮 }
 AddNewFunc(6,@AddNewFuncDefs,P);

 (*
 { 塞 3 㭪樨 אַ 맮   }
 with Pars[1] do begin
  ParType:=dctFloat;
  PascalType:=pptLong;
  ByValue:=False{True}
 end;
 AddDirectCall(wcFunc,'LPOPOLAM',1,Pars,rtFloat,prtLong{prtDouble},@My,False);

 with Pars[1] do begin
  ParType:=dctString;
  PascalType:=pptString;
  ByValue:=False
 end;
 AddDirectCall(wcFunc,'SPLUS',1,Pars,rtString,prtString,@My1,False);

 with Pars[1] do begin
  ParType:=dctAnyArray;
  PascalType:=pptArray;
  ByValue:=True
 end;
 AddDirectCall(wcFunc,'WHATARRAY',1,Pars,rtString,prtString,@WhatArray,False);
 *)

 Fir:=9;

 For I:=1 to Fir do AddFunction(PUserFunc(Funcs[I]));
 AddFunction(F2);
 AddFunction(F1);
 AddFunction(F3);
 AddFunction(F4);

 { 塞 ⨯ 짮⥫ }
 AddUserType('FILE', FileTypeId);
 { 塞 ⠭ }
 AddUserConst('FMOPEN', 0);
 AddUserConst('FMCREATE', 1);
 { 塞 䠩 ⮤ }
 AddProcedure(New(PAssignFile,Init));
 AddFunction(New(POpenFile,Init));
 AddProcedure(New(PCloseFile,Init));
 AddFunction(New(PReadWriteFile,Init(0)));
 AddFunction(New(PReadWriteFile,Init(1)));
 AddFunction(New(PfEqualObj,Init));
 {AddFunction(New(PEOFFile,Init));}
 end;
end;

Constructor TRZACompilator.Init;
Begin
 Inherited Init(File2x2,File2x2out);
 PasTextFiles:=New(PCollection, Init(10,5));
End;

Destructor TRZACompilator.Done;
var P: TPascalTextFile;
Begin
 { ᫨ 짮⥫  ᤥ 맮 CloseFile, ਤ    }
 While PasTextFiles^.Count<>0 do begin
  P:= PasTextFiles^.At(0);
  System.Close(P^);
  Dispose(P);
  PasTextFiles^.AtDelete(0)
 end;
 Dispose(PasTextFiles, Done);
 Inherited Done
End;

Var Event0:TEvent; Error:integer;
Begin
  MaxHeapSize:=4*64*(1024 div 16);
  Timer:=Ptr(Seg0040,$006C);
  AddTerms(Manager2x2);
  EditorDialog:=StdEditorDialog;
  EApp.Init;
  With Event0 do begin
   What:=evCommand; Command:=cmMenu
  end;
  EApp.PutEvent(Event0);
  EApp.Run;
  EApp.Done;
  Dispose(Manager2x2,Done);
  writeln('delta=',Ti2-Ti1,',',ti2);
End.
