Unit MatrSim;

Interface

Uses MatrDef,Diffy;

Procedure Mfsd(M:PMatrix; EPS:real; Var IER:integer);
{ ਧ ᨬ. ⥫쭮 ।  }

Procedure Sinv(M:PMatrix; EPS:real; Var IER:integer);
{ 饭 ᨬ. ⥫쭮 ।  }

Implementation

Procedure Mfsd(M:PMatrix; EPS:real; Var IER:integer);
{ ਧ ᨬ. . ।.  ⮤ }
{ . ୥ 檮 M=R^R; M->SimmM;            }
{ Eps=⭮.  (筮)                        }
Var
 Kpiv,Lanf,Lind,Ind,K,I,Lend,L:integer;
 Tol,Sum,Dpiv:extended;
Begin
 IER:=0;
 Kpiv:=0;

 For K:=1 to M^.Cols do begin
  Inc(Kpiv,K); Ind:=Kpiv; Lend:=K-1;
  Tol:=Abs(EPS*PFloat(M^.Get(Kpiv))^);
  For I:=K to M^.Cols do begin
   Sum:=0;
   If Lend<>0 then
    For L:=1 to Lend do begin
     Lanf:=Kpiv-L; Lind:=Ind-L;
     Sum:=Sum+PFloat(M^.Get(Lanf))^*PFloat(M^.Get(Lind))^
    end;
   Sum:=PFloat(M^.Get(Ind))^-Sum;

   If I=K then begin
    If Sum<=Tol then
     If Sum<=0 then begin
      IER:=-1; exit
     end
     else
      If IER<=0 then IER:=K-1;

    Dpiv:=Sqrt(Sum);
    M^.Put(Kpiv,@Dpiv);
    Dpiv:=1/Dpiv
   end

   else begin
    Sum:=Sum*Dpiv;
    M^.Put(Ind,@Sum)
   end;
   Inc(Ind,I)
  end;
 end
End;

Procedure Sinv(M:PMatrix; EPS:real; Var IER:integer);
{ 饭 ᨬ. . ।.   . 䠪ਧ樨 }
{ MFSD }
Var
 N:byte;
 I,Min,K,Kend,L,Ipiv,Ind,Lanf,J,Lhor,Lver:integer;
 Din,Work:extended;
Begin
 If M^.GetMatrixType<>SimmM then begin
  IER:=-2; exit
 end;

 Mfsd(M,EPS,IER);
 If IER<0 then exit;

 N:=M^.Cols;
 Ipiv:=(N*(N+1)) div 2; Ind:=Ipiv;

 For I:=1 to N do begin
  Din:=1/PFloat(M^.Get(Ipiv))^;
  M^.Put(Ipiv,@Din);
  Min:=N; Kend:=I-1; Lanf:=N-Kend;
  If Kend>0 then begin
   J:=Ind;
   For K:=1 to Kend do begin
    Work:=0; Dec(Min); Lhor:=Ipiv; Lver:=J;
    For L:=Lanf to Min do begin
     Inc(Lver); Inc(Lhor,L);
     Work:=Work+PFloat(M^.Get(Lver))^*PFloat(M^.Get(Lhor))^
    end;
    Work:=-Work*Din;
    M^.Put(J,@Work);
    Dec(J,Min);
   end
  end;
  Dec(Ipiv,Min); Dec(Ind)
 end;

 For I:=1 to N do begin
  Inc(Ipiv,I); J:=Ipiv;
  For K:=I to N do begin
   Work:=0; Lhor:=J;
   For L:=K to N do begin
    Lver:=Lhor+K-I;
    Work:=Work+PFloat(M^.Get(Lver))^*PFloat(M^.Get(Lhor))^;
    Inc(Lhor,L)
   end;
   M^.Put(J,@Work);
   Inc(J,K)
  end
 end
End;

End.