{ (c) Copyright 1995,1997 㭨 .. bunin@mes.djug.pyatigorsk.su }
Unit Calcer;
{$B-,F+,A+,N+,R-,S-,V-,I-,G+,X+,T-}

Interface
Uses Def2x2,Matrdef,Diffy,Objects,X1,MyString,TPInline;

Type

 Float=extended;
 PFloat=^Float;
 PPointer=^pointer;

 PTermTree=^TTermTree;
 TTermTree=record       { - ॢ -    }
  Tail,Head:PTermTree;  { ࠢ,  ॢ }
  TermType:OpsType;     { ⨯ ଠ            }
  case integer of
   0:(What:integer);    {  ଠ (-)     }
   1:(WhatR:pointer);   { 㪠⥫   ଠ }
 end;

 PExpression=^TExpression;
 TExpression=record   { .ࠦ }
  FTree:PTermTree;    { ॢ ࠦ }
  LocX,LocY:word;     {  1- ଠ }
  NCalc:word;         { ᫮ 権 }
 end;

 TCalcCell=record    { - - - }
  CellType:OpsType;  { opPar,opFunc,opConst; opConst--  㦭 }
  Ref:pointer;       { 㪠-  - }
  T1,T2:pointer;     { 㪠-   }
  Aux:pointer;
  case integer of    { १-  }
   0:(ResultF:Float);
   1:(ResultB,JmpRel:boolean; JmpInd:integer);
   2:(ResultP:PText);
   3:(Nop:pointer; MaySimple:boolean); { -   }
 end;
 ACalcStack=array[1..100] of TCalcCell;
 PCalcStack=^ACalcStack;

 PHashCell=^THashCell;
 THashCell=record     {  -⠡ }
  Name:TermString;    {  ଠ }
  TermType:OpsType;   { ⨯ ଠ }
  What:integer;       {  ଠ }
  HFlags:word;        { 䫠 }
  Next:PHashCell;
  HVal:PHashCell;
  HData:pointer;      { PFunction/PStructDef/PUserObject }
  case integer of
   0: (ValueF:Float); { 祭 ६-, - }
   1: (ValueP:PText); { 祭 ⥪. ६-, - }
   2: (Nop,Nop1:pointer);
  end;

 TFuncPars=record   { ଠ - - }
  TermType:OpsType; { ⨯ - }
  Hash:PHashCell;   {  - }
  UTFlag:word;
 end;

 { ᨢ 䠪. - - }
 AFuncFacts=array[0..MaxFuncPars] of TExpression;
 PFuncFacts=^AFuncFacts;

 PMultiParRec=^TMultiParRec;
 TMultiParRec=record { ⥫ ࠦ ⨯ࠬ }
  WhatExpr:TMultiExprType; { 䠪. ⨯ ⨯- }
  Expr:pointer;            { ॢ ࠦ }
  Aux:integer;
  ByValue:boolean;         { True ᫨ ।  祭 }
  Prev:PMultiParRec        {  ࣠樨 ᯨ᪠ }
 end;

 PFunction=^TFunction;
 TFunction=record	{ ᠭ - }
  NPars:byte;		{ ᫮ 㬥⮢ }
  NParVars:byte;	{ ᫮ -, ।  뫪 }
  FuncName:PHashCell;	{   - }
  FuncFlags:word;
  MinFactArgs:integer;
  FuncCalc:pointer;	{ - - (TCalcer)/PDirectCall }
  Pars:array[1..MaxFuncPars] of TFuncPars; { ଠ - }
 end;

 _PFunction=^_TFunction;
 _TFunction=record
  NPars:byte;
  NParVars:byte;
  FuncName:PHashCell;
  FuncFlags:word;
  MinFactArgs:integer;
  FuncCalc:pointer;
 end;

 PCellList=^TCellList;
 TCellList=record       { ᠭ - ᨢ }
  F:TExpression;        { ࠦ 祭 }
  Next:PCellList
 end;

 PArrayDef=^TArrayDef;
 TArrayDef=record
  Cells:word;         { ᪮쪮  ⮢ }
  Extern:boolean;     { -   }
  Size1,Size2:word;   { ࠧ }
  CellList:PCellList; { - - }
 end;

 PStructDef=^TStructDef;
 TStructDef=record     { ᠭ ᨢ,  }
  Data:pointer;        { PMatrix/PPolinom }
  NameHash:PHashCell;  {   }
  ArrDef:PArrayDef;
  MType:MatrixType;    { ⨯ - }
 end;

 PFormula=^TFormula;
 TFormula=record   { 㫠 }
  E:TExpression;   { ࠦ }
  Loc:PHashCell    { Hash   }
 end;

 PObjFormula=^TObjFormula;
 TObjFormula=record   { 㫠 }
  E:TExpression;      { ࠦ }
  Loc:PHashCell;      { Hash   }
  LObj:pointer;
  LWhatObj,RWhatObj:OpsType;
 end;

 PPropFormula=^TPropFormula;
 TPropFormula=record
  LValue:TExpression; { ࠦ }
  RValue:TExpression; { ࠦ }
  Func:PFunction;
  Loc:PHashCell       { Hash   }
 end;

 PArrayCell=^TArrayCell;
 TArrayCell=record   { 㫠- ᨢ }
  Loc:PHashCell;     { Hash  }
  RefArr:boolean;
  Index,Index2,FTree:TExpression {    祭 }
 end;

 PLogicTree=^TLogicTree;
 TLogicTree=record      { logic-ࠦ }
  LogicOp:byte;         { ⨯ logic-樨 }
  What:byte;            { ⨯ ࠦ: logic,bool }
  Left,Right:pointer    { ,ࠢ ࠦ }
 end;

 PBoolExpression=^TBoolExpression;
 TBoolExpression=record  { bool-ࠦ }
  What:byte;             { ⨯ 樨   }
  Left,Right:TExpression { ,ࠢ .ࠦ }
 end;

 PBlockList=^TBlockList;
 TBlockList=record         {  ᫥ }
  What:ExprType;           { ⨯  }
  Next:PBlockList;
  case integer of
   0:(NBlocks:word;                 { ᫮  }
      NDefBlocks,NStructDefs:byte); { ᫮ ᠭ }
   1:(Expr:pointer;)       {  }
 end;

 PCaseList=^TCaseList;
 TCaseList=record
  CaseValue:TExpression;
  CaseBlock:PBlockList;
  RelWhat:word;
  Next:PCaseList
 end;

 PCaseOp=^TCaseOp;
 TCaseOp=record
  CaseExpr:TExpression;
  Cases:PCaseList;
  NCases:word;
  WhatCase:integer;
  ElseBlock:PBlockList;
 end;

 PWhileCycle=^TWhileCycle;
 TWhileCycle=record      {  While }
  LogCalcs:word;         { ᫮ . 権  ᫮ }
  Logic:PLogicTree;      { ॢ - ᫮ }
  BList:PBlockList       {  -  while }
 end;

 PIfCycle=^TIfCycle;
 TIfCycle=record        {  If-else }
  LogCalcs:word;        { ᫮ . 権  ᫮ }
  Logic:PLogicTree;     { ॢ - ᫮ }
  BListIf,BListElse:PBlockList {  -  if  else }
 end;

 PPrintRec=^TPrintRec;
 TPrintRec=record	{ - ᯨ᪠ 뢮 - Print }
  F:TExpression;	{ - - }
  Expo:boolean;		{ True, ᫨ exp ଠ }
  F1,F2:byte		{  ଠ :F1:F2 }
 end;

 TDirectCallPar=record  { ⥫ - אַ 맮 }
  ParType:T2x2Type;       { ⨯ 22 }
  PascalType:TPasParType; { ⨯ Pascal }
  ByValue:boolean         { True ᫨ ।  祭 }
 end;
 { ᨢ ⥫ - אַ 맮 }
 TDirectCallPars=array[1..MaxFuncPars] of TDirectCallPar;

 TDirectStack=word;

 TCallPrepare=record { ⥫ ନ஢⥫ ⥪ }
  From:pointer; {  䠪. - }
  ToOfs:word;   { ᬥ饭  DirectStack }
  Aux:pointer;  { 㪠⥫  祭 楫, ।  뫪 }
  What:word     { ⨯ }
 end;
 { ᨢ ନ஢⥫ ⥪ }
 ACallPrepares=array[0..1] of TCallPrepare;
 PCallPrepares=^ACallPrepares;

 ArOfWord=array[0..1] of word;
 PArOfWord=^ArOfWord;

 PDirectCall=^TDirectCall;    { ⥫ ணࠬ אַ 맮 }
 TDirectCall=record
  ParsNum:integer;            { - - }
  WhatReturn:TReturnType;     { ⨯ 22 頥 祭 }
  PasReturn:TPasReturnType;   { ⨯ Pascal 頥 祭 }
  FuncAdr:pointer;            {  - }
  CallStackSize:word;         { ࠧ ⥪ }
  PrepareSize:word;           { ࠧ ନ஢⥫ ⥪  AfterPrepare }
  AfterPrepare:word;          { ࠧ ନ஢⥫  祭  뫪 }
  TemplatePrep:PCallPrepares; { ନ஢⥫ ⥪ }
  TmpAr:PArOfWord;            {  ࠭ 楫, ।  뫪 }
  CallStack:TDirectStack      { ⥪ 맮 }
 end;

 PObjScan=^TObjScan;
 TObjScan=record
  FieldNum:integer;
  OData:PObjScan;
  ObjDef:pointer; { P2x2Object }
  Prev:PObjScan;
 end;

 PFieldRef=^TFieldRef;
 TFieldRef=record
  FieldNum:integer;
  Obj:PObjScan;
  FFlags:word
 end;

 PCalcer=^TCalcer;
 TCalcer=object(TObject)  { ꥪ-᫨⥫ }
  procedure Evaluate;virtual;
  function Calculate:PFloat;virtual;
 end;

 { - . ࠦ }
 PExpressionCalcer=^TExpressionCalcer;
 TExpressionCalcer=object(TCalcer)
  Calcs:word;
  CalcStack:PCalcStack;
  ENeed:boolean;
  procedure BuildCalcStack(Tree:PTermTree; Var Need:boolean);
  constructor Init(Const F:TExpression);
  destructor Done;virtual;
  function Calculate:PFloat;virtual;
  procedure Evaluate;virtual;
  procedure Simplify;
 end;

 { - ப ࠦ }
 PStrExpressionCalcer=^TStrExpressionCalcer;
 TStrExpressionCalcer=object(TExpressionCalcer)
  function Calculate:PFloat;virtual;
 end;

 { - .  ᢠ }
 PFormulaCalcer=^TFormulaCalcer;
 TFormulaCalcer=object(TExpressionCalcer)
  ResAd:PFloat;
  LHash:PHashCell;
  constructor Init(F:PFormula);
  procedure Evaluate;virtual;
 end;

 { - .  ᢠ }
 PRefFormulaCalcer=^TRefFormulaCalcer;
 TRefFormulaCalcer=object(TExpressionCalcer)
  Field:TFieldRef;
  IsFloat:boolean;
  constructor Init(F:PFormula; AIsFloat:boolean);
  procedure Evaluate;virtual;
 end;

 { -  ᢠ 祭 ꥪ }
 PObjFormulaCalcer=^TObjFormulaCalcer;
 TObjFormulaCalcer=object(TCalcer)
  Calcs:word;
  CalcStack:PCalcStack;
  LeftObj,ObjDef:PObject;
  RefObj:boolean;
  constructor Init(F:PObjFormula);
  procedure Evaluate;virtual;
  procedure BuildCalcStack(Tree:PTermTree);
  destructor Done;virtual;
 end;

 PObjRefCalcer=^TObjRefCalcer;
 TObjRefCalcer=object(TCalcer)
  LeftObj,RightObj:pointer;
  LRefObj,RRefObj:boolean;
  constructor Init(LWObj,RWObj:OpsType; OLoc:PHashCell; E:pointer);
 end;

 PObjRefCompareCalcer=^TObjRefCompareCalcer;
 TObjRefCompareCalcer=object(TObjRefCalcer)
  EqualOp:boolean;
  function CalculateB:boolean;virtual;
 end;

 { -  ᢠ ꥪ⭮ 뫪 }
 PObjRefFormulaCalcer=^TObjRefFormulaCalcer;
 TObjRefFormulaCalcer=object(TObjRefCalcer)
  constructor Init(F:PObjFormula);
  procedure Evaluate;virtual;
 end;

 { -  ᢠ --property }
 PFuncPropCalcer=^TFuncPropCalcer;
 TFuncPropCalcer=object(TCalcer)
  FR,FL:PExpressionCalcer;
  RightVal:pointer;
  constructor Init(F:PPropFormula);
  procedure Evaluate;virtual;
  destructor Done;virtual;
 end;

 PProcCalcer=^TProcCalcer;
 TProcCalcer=TExpressionCalcer;

 { - ப  ᢠ }
 PStrFormulaCalcer=^TStrFormulaCalcer;
 TStrFormulaCalcer=object(TExpressionCalcer)
  StrAd:PText;
  LHash:PHashCell;
  constructor Init(F:PFormula);
  procedure Evaluate;virtual;
 end;

 { -  ᢠ - ୮ - }
 PArrayCalcer=^TArrayCalcer;
 TArrayCalcer=object(TCalcer)
  MC:pointer;
  IndexC,ValC:PExpressionCalcer;
  Field:integer;
  ByRef:boolean;
  constructor Init(F:PArrayCell; What:integer);
  procedure Evaluate;virtual;
  destructor Done;virtual;
 end;

 { -  ᢠ - 㬥୮ - }
 PMatrixCalcer=^TMatrixCalcer;
 TMatrixCalcer=object(TArrayCalcer)
  Index2C:PExpressionCalcer;
  constructor Init(F:PArrayCell);
  procedure Evaluate;virtual;
  destructor Done;virtual;
 end;

 { - ᪮ ࠦ }
 PLogicCalcer=^TLogicCalcer;
 TLogicCalcer=object(TCalcer)
  Calcs:word;
  CalcStack:PCalcStack;
  procedure BuildCalcStack(Tree:PLogicTree);
  constructor Init(ACalcs:word; Tree:PLogicTree);
  procedure Evaluate;virtual;
  function CalculateB:boolean;
  destructor Done;virtual;
 end;

 { -  If }
 PIfCalcer=^TIfCalcer;
 TIfCalcer=object(TCalcer)
  Condition:PLogicCalcer;
  BodyIf,BodyElse:PCalcer;
  constructor Init(P:PIfCycle);
  procedure Evaluate;virtual;
  destructor Done;virtual;
 end;

 { -  While }
 PWhileCalcer=^TWhileCalcer;
 TWhileCalcer=object(TCalcer)
  Condition:PLogicCalcer;
  Body:PCalcer;
  constructor Init(P:PWhileCycle);
  procedure Evaluate;virtual;
  destructor Done;virtual;
 end;

 { -  Break,Continue,Exit }
 PBCECalcer=^TBCECalcer;
 TBCECalcer=object(TCalcer)
  What:TRunControl;
  constructor Init(AWhat:TRunControl);
  procedure Evaluate;virtual;
 end;

 CalcerAr=array[1..2] of PCalcer;
 PCalcerAr=^CalcerAr;

 { -  ஢ }
 PBlockCalcer=^TBlockCalcer;
 TBlockCalcer=object(TCalcer)
  Operators:PCalcerAr;
  Calcs:word;
  Count:word;
  Global:boolean;
  First,Last:word;
  constructor Init(B:PBlockList; AGlobal:boolean);
  procedure Evaluate;virtual;
  destructor Done;virtual;
 private
  function CompileArrayDef(PS:PStructDef):boolean;
  function CompileFuncDef(PBL:PBlockList):boolean;
  function DoObjectDef(Obj:pointer):boolean;
 end;

 TCaseFloatRec=record
  case Calced:integer of
   0: (FloatVal:Float);
   1: (FloatExpr:PExpressionCalcer);
 end;

 TCaseStrRec=record
  case Calced:integer of
   0: (StrVal:PString);
   1: (StrExpr:PStrExpressionCalcer);
 end;

 TCasesRec=record
  CaseBlock:PBlockCalcer;
  NextJump:WordBool; { True ᫨ NexrCase }
  RelFunc:pointer; { - ࠢ }
  case integer of
   0: (CFR:TCaseFloatRec);
   1: (CSR:TCaseStrRec);
 end;

 TCases=array[0..1] of TCasesRec;
 PCases=^TCases;

 { -  Case }
 PCaseCalcer=^TCaseCalcer;
 TCaseCalcer=object(TCalcer)
  WCase:integer;
  CaseCnt:integer;
  CaseExpression:PExpressionCalcer;
  BodyElse:PBlockCalcer;
  CaseValues:pointer;
  FCases:PCases;
  constructor Init(P:PCaseOp);
  procedure Evaluate;virtual;
  destructor Done;virtual;
 end;

 P2x2Function=^T2x2Function;
 T2x2Function=object(TCalcer)
  HFunc:PHashCell;   {  - }
  procedure SetParValue(ParNum:integer; var AValue);
  procedure GetParValue(ParNum:integer; var AValue);
  function GetRawParValue(ParNum:integer):pointer;
  procedure SetRawParValue(ParNum:integer; AValue:pointer);
  function GetFuncDef:PFunction;virtual;
  function GetFuncType:word;virtual;
  function ParCount:integer;
  procedure ParTypes(var PTypes:array of T2x2Type; var ByValue:array of boolean);
  function ObjectArgType(ParNum:integer):PObject;
  function FuncParArgs(ParNum:integer):string;
  function Equal(AFunc:PFunction):boolean;
  function FunctionName:string;virtual;
  function GetSelfObject:pointer;virtual;
  procedure PushObjInstance(Obj:pointer);virtual;
  function CallInherit(var Res):boolean;
  function ParsDefine:boolean;virtual;
 end;

 { - - - }
 PUserFuncCalcer=^TUserFuncCalcer;
 TUserFuncCalcer=object(T2x2Function)
  procedure Evaluate;virtual;
  function Calculate:PFloat;virtual;
  function GetFuncType:word;virtual;
  constructor Init(AFunc:PFunction);
  function GetFuncDef:PFunction;virtual;
  function GetFieldNum(FieldName:TermString):integer;
  destructor Done;virtual;
  procedure BuildBlockCalcer(BL:PBlockList);
 private
  F:PFunction;
  BC:PBlockCalcer;
 end;

 { - ⮤ }
 PMethodCalcer=^TMethodCalcer;
 TMethodCalcer=object(TUserFuncCalcer)
  function GetSelfObject:pointer;virtual;
  procedure PushObjInstance(Obj:pointer);virtual;
  procedure SetObjHash(H:PHashCell);
 private
  Obj2x2:PHashCell;
 end;

 { ।  - }
 PMatrixAlloc=^TMatrixAlloc;
 TMatrixAlloc=object(TCalcer)
  Lines,Cols:word;     { ࠧ ᨢ }
  MType:MatrixType;    { ⨯ ᨢ }
  PData:pointer;       { 㪠-  TStructDef.Data }
  constructor Init(ALines,ACols:word; P:PStructDef);
  procedure Evaluate;virtual;
  destructor Done;virtual;
 end;

 { 㭨⮦  - }
 PMatrixDeAlloc=^TMatrixDeAlloc;
 TMatrixDeAlloc=object(TCalcer)
  PData:pointer; { 㪠-  TStructDef.Data }
  constructor Init(P:PStructDef);
  procedure Evaluate;virtual;
 end;

 { -  Print }
 PPrintCalcer=^TPrintCalcer;
 TPrintCalcer=object(TCalcer)
  Operators:PCalcerAr;
  Count:word;
  constructor Init(B:PBlockList);
  procedure Evaluate;virtual;
  destructor Done;virtual;
 end;

 { -, 뢠     Print }
 PFlushLine=^TFlushLine;
 TFlushLine=object(TCalcer)
  Compiler:PCalcer;
  constructor Init;
  procedure Evaluate;virtual;
 end;

 { -, 뢠 - Print  뢮 . ࠦ }
 PExpressionPrint=^TExpressionPrint;
 TExpressionPrint=object(TFlushLine)
  PE:PExpressionCalcer;
  TeF1,TeF2:byte;
  TeExp:boolean;
  constructor Init(F:PPrintRec);
  procedure Evaluate;virtual;
  destructor Done;virtual;
 end;

 { -, 뢠 - Print  뢮 ப ࠦ }
 PStrFormulaPrint=^TStrFormulaPrint;
 TStrFormulaPrint=object(TFlushLine)
  PS:PExpressionCalcer;
  constructor Init(F:PPrintRec);
  procedure Evaluate;virtual;
  destructor Done;virtual;
 end;

const MemRecSize=2048;

Type

 PMemRec=^TMemRec;
 TMemRec=record
  MemAdr:array[0..MemRecSize-1] of char;
  CurSize:word;
  Next:PMemRec
 end;

 { ࠪ  }
 PACompilator=^TACompilator;
 TACompilator=object(TCalcer)
  ErrorX,ErrorY:word; {  訡 }
  TransError:integer; {  訡 }
  TopTerm:PToken;
  JumpPoint:JumpRecord;
  procedure Print(Var S:string); virtual;
  procedure FlushPrintLine; virtual;
  procedure ReadyPrint; virtual;
  function GetFuncAdres(What:word):pointer;virtual;
  function NewMem(Size:word):pointer;
  function NewMemTmp(Size:word):pointer;
  procedure DisposeMem;
  procedure DisposeMemTmp;
  constructor Init;
  destructor Done;virtual;
  procedure MapError(Var Xe,Ye:word);virtual;
  procedure ErrorJump(CheckEnd:integer; Xe,Ye:word; Error:word);
 private
  Mem2x2,Mem2x2Tmp:PMemRec;
  CurMem,CurMemTmp:PMemRec;
 end;

 { 訡  ࠡ - xxxCalcer }
 CompileError=record
  Error:word;
  cX,cY:word;
  ErrorTxt:string[3*MaxTermLen];
 end;

 TSwitchBuffer=record
  SCurComp:PCalcer;
  SCompError:CompileError;
  SDefColl:PCollection;
 end;

procedure ValidName(Var Name:string; Var Error:integer; Var ErrorPos:word);
procedure PrepareToSwitchModule(var SwitchBuf:TSwitchBuffer; ModType:TModuleType);
procedure SwitchModuleBack(var SwitchBuf:TSwitchBuffer; ModType:TModuleType);

Var
 CompError:CompileError;
 DefColl:PCollection; {  ꥪ⮢--  - - }
 CurCompilator:PACompilator;

Implementation
Uses UserFunc;

var RefFunction:TFunction;

{$I FUNCS.PAS}

Const
 { ⥪. ᫮ . - }
 CurLastFunc:word=moPower;
 { ᫮ ⠭. . - }
 LastFuncAdres=moPower;

 {  ⠭. - }

 FuncAdres:array[f1Neg..LastFuncAdres] of pointer=(
  @fNeg, @fSin, @fCos, @fTg, @fAsin, @fAcos, @fArctg,@fAbs, @fSqr, @fSqrt,
  @fRad, @fGrad, @fLn, @fLog, @fExp, @fSign,@fFrac, @fRound, @fTrunc, nil,
  @fError, @fPlus, @fMinus,@fMult, @fDiv, @fLDiv, @fLMod, @fPower);

 BoolFuncAdres:array[rtG..rtsNE] of pointer=(
  @fBG, @fBGE, @fBL, @fBLE, @fBE, @fBNE, @fIsZero, @fIsOne,
  @fsBG, @fsBGE, @fsBL, @fsBLE, @fsBE, @fsBNE );

 LogicFuncAdres:array[ltAND..ltXOR] of pointer=(@fLAnd, @fLOr, @fLNot, @fLXOR);

 StringRelFuncs:array[rtG..rtNE] of pointer=(
  @fcsBG, @fcsBGE, @fcsBL, @fcsBLE, @fcsBE, @fcsBNE);
 FloatRelFuncs:array[rtG..rtNE] of pointer=(
  @fcBG, @fcBGE, @fcBL, @fcBLE, @fcBE, @fcBNE);

 BreakBit=1;
 ContinueBit=2;
 ExitBit=4;
 CalcBreakState:word=0;

Type
 TCalcFunc=procedure(Var P:TCalcCell);
 TCompStrFunc=function(Op1:PText; const Op2:string):boolean;
 TCompFloatFunc=function(Op1,Op2:Float):boolean;

function GetFunc(What:byte):pointer;
begin
 If What>FuncIndex2x2 then GetFunc:=CurCompilator^.GetFuncAdres(What)
 else GetFunc:=FuncAdres[What]
end;

function GetBoolFunc(What:byte):pointer;
begin
 GetBoolFunc:=BoolFuncAdres[What]
end;

function GetLogicFunc(What:byte):pointer;
begin
 GetLogicFunc:=LogicFuncAdres[What]
end;

procedure TCalcer.Evaluate;
begin end;
function TCalcer.Calculate:PFloat;
begin end;

constructor TExpressionCalcer.Init(const F:TExpression);
begin
 GetMem(CalcStack, F.NCalc*SizeOf(TCalcCell));
 Calcs:=0;
 BuildCalcStack(F.FTree,ENeed);
 Simplify
end;

destructor TExpressionCalcer.Done;
begin
 FreeMem(CalcStack, Calcs*SizeOf(TCalcCell));
end;

function TExpressionCalcer.Calculate:PFloat;
begin
 Evaluate;
 Calculate:=@CalcStack^[1].ResultF
end;

function TStrExpressionCalcer.Calculate:PFloat;
begin
 Evaluate;
 Calculate:=PFloat(CalcStack^[1].ResultP)
end;

procedure TExpressionCalcer.BuildCalcStack(Tree:PTermTree; Var Need:boolean);
var Op,Op1:OpsType; K:PTermTree; b,b1,b2:boolean; P,P1:PFunction; N,j,M,L,r:word;
    FF:PFuncFacts; Q:PMultiParRec;

 procedure Leaf(Var T:pointer);near;
 var Op:OpsType;
 begin
  Op:=K^.TermType;
  Case Op of
   opConst:begin
    T:=K^.WhatR; Need:=False
   end;
   opFPar,opFUknown:begin
    T:=@PHashCell(K^.WhatR)^.ValueF; Need:=True
   end;
   opFConst:begin
    T:=@PHashCell(K^.WhatR)^.ValueF; Need:=False
   end;
   else begin
    T:=@CalcStack^[Calcs+1].ResultF;
    BuildCalcStack(K,Need);
   end
  end
 end;

 procedure MoveToRefFunc;near;
 begin
  { 뫪 PFunction .⮤  RefFunction }
  Inc(Calcs);
  With CalcStack^[Calcs],PFuncCall(Q)^ do begin
   CellType:=opFunc;
   Ref:=@fGetVirtFuncDef;
   If b2 then begin { ꥪ ⥭ }
    T1:=CallObj; { PObjScan }
    longint(Aux):=1
   end
   else begin { ꥪ ⥭ }
    T1:=@PHashCell(CallObj)^.HData; { ^PUserObject }
    Aux:=nil
   end;
   longint(T2):=-FuncIndex; {  ⮤ }
   MaySimple:=False;
  end
 end;

 procedure ArByRef(a1:pointer; a2:PFieldRef; ForArg:boolean);near;
 begin
  Inc(Calcs);
  With CalcStack^[Calcs] do begin
   Aux:=a1; { @From/@T2 }
   CellType:=opFunc;
   MaySimple:=False;
   T1:=a2^.Obj; { PObjScan }
   longint(T2):=a2^.FieldNum; { #  }
   If ForArg then Ref:=@fGetRefArray else Ref:=@fGetRefArray1
  end
 end;

 procedure ParByRef(a1:pointer; a2:PFieldRef);near;
 begin
  Inc(Calcs);
  With CalcStack^[Calcs] do begin
   Aux:=a1; { @From/@T2 }
   ResultP:=nil;
   CellType:=opFunc;
   MaySimple:=False;
   T1:=a2^.Obj; { PObjScan }
   longint(T2):=a2^.FieldNum; { #  }
   Ref:=@fGetRefPar
  end
 end;

 procedure ObjByRef(a1:pointer; a2:PObjScan);near;
 begin
  Inc(Calcs);
  With CalcStack^[Calcs] do begin
   CellType:=opFunc;
   MaySimple:=False;
   T2:=a2; { PObjScan }
   T1:=a1; { @From }
   Ref:=@fGetRefObject
  end
 end;

begin
 Inc(Calcs);
 With CalcStack^[Calcs] do begin
  Op:=Tree^.TermType;

  Case Op of
   opConst:begin
    CellType:=opConst;
    ResultF:=PFloat(Tree^.WhatR)^;
    Need:=False; exit
   end;

   opFunc1:begin
    CellType:=opFunc;
    K:=Tree^.Head; Leaf(T1);
    Ref:=GetFunc(Tree^.What)
   end;

   opFunc2:begin
    CellType:=opFunc;
    K:=Tree^.Tail; Leaf(T2); b:=Need;
    K:=Tree^.Head; Leaf(T1); Need:=Need or b;
    Ref:=GetFunc(Tree^.What)
   end;

   opFConst:begin
    CellType:=opConst; ResultF:=PHashCell(Tree^.WhatR)^.ValueF;
    Need:=False; exit
   end;

   opArrayVar,{opPolinom,}opStrArrVar,opRefArrayVar,opRefStrArrVar:begin
    CellType:=opFunc;
    K:=Tree^.Head; Leaf(T1); { 1-  }
    case Op of
     opRefArrayVar,opRefStrArrVar: ArByRef(@T2,Tree^.WhatR,False);
     else T2:=PHashCell(Tree^.WhatR)^.HData; { PStructDef }
    end;
    {If Op=opPolinom then Ref:=CalcPolinomAddres
    else}
     If Tree^.Tail=nil then { 饭   - }
      If Op=opStrArrVar then Ref:=@fCalcStrArray else Ref:=@fCalcArray
     else begin { 饭   2-୮ - }
      K:=Tree^.Tail; Leaf(Aux); { 2-  }
      Ref:=@fCalcMatrix
     end;
    Need:=True
   end;

   opDirectFunc,opDirectStrFunc,opDirectProc:begin
    P:=PFunction(PHashCell(Tree^.WhatR)^.HData);
    FF:=PFuncFacts(Tree^.Head); { 䠪᪨ ࠬ }
    { 맮 - }
    CellType:=opFunc;
    Ref:=@fCalcDirectSubr;
    T1:=P^.FuncCalc; { PDirectCall }
    If Op=opDirectStrFunc then ResultP:=CurCompilator^.NewMem(TextTermSize);

    With PDirectCall(P^.FuncCalc)^ do begin
     { ।塞 TCallPrepare }
     J:=(PrepareSize+AfterPrepare)*SizeOf(TCallPrepare);
     T2:=CurCompilator^.NewMem(J);
     FastMove(TemplatePrep^,T2^,J);
     b1:=P^.FuncFlags and ffSimpleIfAllConst<>0;

    For N:=1 to P^.NPars do
     with PCallPrepares(T2)^[N-1] do begin
      Op1:=P^.Pars[N].TermType; { ଠ쭮 ᠭ }
      Case Op1 of
       opFUknown,opUserVar:begin { Float,UserType  祭 }
        From:=@CalcStack^[Calcs+1].ResultF;
        BuildCalcStack(FF^[N].FTree,b); {  । - }
        b1:=b1 and not b;
       end;
       opFPar,opUserPar:begin { Float,UserType  뫪 }
        If FF^[N].NCalc=0 then begin
         Q:=@PHashCell(FF^[N].FTree)^.ValueF;
         If longint(From)<>-1 then PCallPrepares(T2)^[longint(From)].From:=Q;
         From:=Q
        end
        else begin
         ParByRef(@From,PFieldRef(FF^[N].FTree));
         If longint(From)<>-1 then
          CalcStack^[Calcs].ResultP:=@PCallPrepares(T2)^[longint(From)].From;
        end
       end;
       opSUknown:begin { String  祭 }
        M:=Calcs+1;
        BuildCalcStack(FF^[N].FTree,b);
        b1:=b1 and not b;
        From:=@CalcStack^[M].ResultP;
       end;
       opSPar: { String  뫪 }
        If FF^[N].NCalc=0 then From:=PHashCell(FF^[N].FTree)^.ValueP
        else ParByRef(@From,PFieldRef(FF^[N].FTree));
       opArrayVar..opStrArrVar,opAnyArrVar: { @Data 䠪- ᨢ/ }
        If FF^[N].NCalc=0 then From:=@PStructDef(PHashCell(FF^[N].FTree)^.HData)^.Data
        else ArByRef(@From,PFieldRef(FF^[N].FTree),True);
       opObject,opObjectRef,opObjectType:
        If FF^[N].NCalc=0 then From:=@PHashCell(FF^[N].FTree)^.HData { ^PUserObject }
        else ObjByRef(@From,PObjScan(FF^[N].FTree));
      end;
     end;
    {   ப }
     case Op of
      opDirectFunc:
       with PCallPrepares(T2)^[PrepareSize+AfterPrepare-1] do From:=@ResultF;
      opDirectStrFunc: with PCallPrepares(T2)^[P^.NPars] do From:=ResultP;
     end
    end;
    Need:=not b1;
   end;

   opParProc..opStringFunc,opUserProc:begin
    Q:=pointer(Tree^.Tail); { PFuncCall }
    If Q=nil then begin { 筠 㭪 }
     P:=PFunction(PHashCell(Tree^.WhatR)^.HData);
     P1:=P;
     b:=False;
    end
    else with PFuncCall(Q)^ do begin { ⮤ }
     P:=Func;
     P1:=P;
     b:=P^.FuncFlags and ffVirtual<>0; { - - 㠫쭠 ? }
     { True ᫨ 맮 ⮤ - 㠫 }
     b:=b and (CallFlags and cfVirtual<>0);
     If b then P:=@RefFunction; { ४砥 P  ६  }
     b2:=CallFlags and cfRefObj<>0;
    end;

    FF:=PFuncFacts(Tree^.Head); { 䠪᪨ ࠬ }
    J:=Calcs;
    { ⠢塞    - ६-뫮 }
    Inc(Calcs, P1^.NParVars);

    Case Op of
     opParProc,opUserProc: Dec(j);
     else begin
      { । १ - }
      CellType:=opFPar;
      { ⠢塞    - - }
      Inc(Calcs);
      T1:=@CalcStack^[Calcs].ResultF;
     end
    end;
    r:=Pred(Calcs);

    { 맮 - }
    With CalcStack^[Calcs] do begin
     CellType:=opFunc;
     { b1=True ᫨ opParFunc,opParProc,opParStrFunc - ᢥ 맮 }
     { opParxxx ᫨  ---  . ⮤ ꥪ }
     If b then longint(Aux):=1 else Aux:=nil;
     Case Op of
      opParFunc:begin
       T1:=P; Ref:=@fCalcUserParFunc; b1:=True
      end;
      opParProc:begin
       T1:=P; Ref:=@fCalcUserParProc; b1:=True
      end;
      opParStrFunc:begin
       T1:=P; Ref:=@fCalcUserParStrFunc; b1:=True;
       ResultP:=CurCompilator^.NewMem(TextTermSize);
      end;
      else begin
       b1:=False;
       T1:=P^.FuncCalc;  { PCalcer }
       T2:=@P^.FuncName^.ValueF; {  頥 祭: @Float/@PText }
       Case Op of
        opStringFunc:begin
         Ref:=@fCalcStringFunc;
         ResultP:=CurCompilator^.NewMem(TextTermSize);
        end;
        opUserProc: Ref:=@fCalcUserProc;
        else Ref:=@fCalcUserFunc
       end
      end
     end;
     MaySimple:=False
    end;

    If Q<>nil then begin { ⮤ ꥪ }
     { ।  ⮤   ꥪ }
     Inc(Calcs);
     with CalcStack^[Calcs] do begin
      CellType:=opFunc;
      MaySimple:=False;
      with PFuncCall(Q)^ do
       If not b2 then begin
        { ꥪ - ⥭ }
        T1:=@PHashCell(CallObj)^.HData; { ^PUserObject }
        Aux:=nil
       end
       else begin { ꥪ - ⥭ }
        T1:=CallObj; { PObjScan }
        longint(Aux):=1;
       end;
      If b then begin { 㠫 맮 }
       T2:=P;
       Ref:=@fMailVirtObjInstance;
      end
      else begin { ᪨ 맮 }
       T2:=P^.FuncCalc;  { PCalcer }
       Ref:=@fMailObjInstance
      end
     end
    end;

    If P1^.NPars=0 then begin
     If b then MoveToRefFunc
    end
    else begin
     If P1^.MinFactArgs<>P1^.NPars then begin
      Inc(Calcs);
      { ।  - - 䠪᪨ - }
      with CalcStack^[Calcs] do begin
       CellType:=opFunc;
       longint(T1):=FF^[0].LocY;
       If b1 then begin
        T2:=P; Ref:=@fMailVirtFactCnt
       end
       else begin
        T2:=P^.FuncCalc; Ref:=@fMailFactCnt
       end;
       MaySimple:=False;
      end
     end;
     M:=Calcs;

     Inc(Calcs,FF^[0].LocY+FF^[0].LocX);
     { FF^[0].LocY = 䠪᪮ - - - }
     { FF^[0].LocX = ᫮ ࠬ஢   ⨯ࠬ - }
     {  P^.NPars=0 FF  । }
     L:=Calcs;
     If b then MoveToRefFunc;{ 㠫 뫮 ⮤ }

     { M+1..M+NPars+FF^[0].LocX = 祩  । 祭 䠪.㬥⮢  - }
     { Calcs+1...   = 祩   祭 䠪. -  - }

     { M     -  । -
       J     -   祭 -, ।  뫪
       Calcs -   祭 - }

     For N:=1 to FF^[0].LocY do begin { 横  䠪.- }
      Inc(M);
      Op1:=P1^.Pars[N].TermType; { ⨯ ଠ쭮 - }

      Case Op1 of
       opFUknown,opSUknown,opUserVar: {  祭 }
       With CalcStack^[M] do begin
        { । - }
        CellType:=opFunc;
        { T1 - 㤠 । - - }
        If b1 then begin
         {  ---   ⭮,   ᠬ । -
         -,    ,    -   }
         T1:=@P^.Pars[N].Hash;
         If Op1=opSUknown then Ref:=@fMailStrPar else Ref:=@fMailFloatPar
        end
        else begin
         T1:=@P^.Pars[N].Hash^.ValueF;
         If Op1=opSUknown then Ref:=@fPopStrPar else Ref:=@fPopFloatPar
        end;
        { T2 -  । }
        T2:=@CalcStack^[Calcs+1].ResultF;
        MaySimple:=False;
        BuildCalcStack(FF^[N].FTree,B); {  । - }
       end;

       opFPar,opSPar,opUserPar:begin {  뫪 }
        { । - -  - }
        With CalcStack^[M] do begin
         CellType:=opFunc;
         If b1 then begin
          T1:=@P^.Pars[N].Hash;
          If Op1=opSPar then Ref:=@fMailStrPar else Ref:=@fMailFloatPar
         end
         else begin
          T1:=@P^.Pars[N].Hash^.ValueF;
          If Op1=opSPar then Ref:=@fPopStrPar else Ref:=@fPopFloatPar
         end;
         If FF^[N].NCalc=0 then T2:=@PHashCell(FF^[N].FTree)^.ValueF
         else begin
          ParByRef(@T2,PFieldRef(FF^[N].FTree));
          CalcStack^[Calcs].ResultP:=@CalcStack^[J+1].T1;
         end;
         MaySimple:=False;
        end;
        {  - - }
        Inc(J);
        With CalcStack^[J] do begin
         CellType:=opFunc;
         If b1 then
          If Op1=opSPar then Ref:=@fMailStrParBack else Ref:=@fMailFloatParBack
         else
          If Op1=opSPar then Ref:=@fPopStrPar else Ref:=@fPopFloatPar;
         T1:=CalcStack^[M].T2; { 㤠  - }
         T2:=CalcStack^[M].T1; {   }
         MaySimple:=False;
        end;
       end;

       opArrayVar..opStrArrVar,opAnyArrVar:
        With CalcStack^[M] do begin
         CellType:=opFunc;
         If b1 then begin
          T1:=@P^.Pars[N].Hash; Ref:=@fMailStruct
         end
         else begin
          { 㤠 । =  - Data}
          T1:=@PStructDef(P^.Pars[N].Hash^.HData)^.Data;
          Ref:=@fPopStructAddres;
         end;
         If FF^[N].NCalc=0 then
          {  ।: @Data 䠪- ᨢ/ }
          T2:=@PStructDef(PHashCell(FF^[N].FTree)^.HData)^.Data
         else ArByRef(@T2,PFieldRef(FF^[N].FTree),True);
         MaySimple:=False;
        end;

       opUserFunc,opUserProc:
        With CalcStack^[M] do begin
         CellType:=opFunc;
         If b then begin
          T1:=@P^.Pars[N].Hash;
          Ref:=@fMailVirtPFunction; { ४稢 TFunction }
         end
         else begin
          { 㤠 । =  - PFunction }
          T1:=PFunction(P^.Pars[N].Hash^.HData);
          Ref:=@fPopPFunction; { ४稢 TFunction }
         end;
         {  । =  䠪. PFunction }
         T2:=PHashCell(FF^[N].FTree)^.HData;
         MaySimple:=False;
        end;

       opObject,opObjectRef,opObjectType:begin
        { । - }
        With CalcStack^[M] do begin
         CellType:=opFunc;
         If Op1=opObject then Aux:=nil else longint(Aux):=1;
         If b1 then begin
          T1:=@P^.Pars[N].Hash; Ref:=@fMailObject;
         end
         else begin
          T1:=@P^.Pars[N].Hash^.HData; Ref:=@fPopObject;
         end;
         If FF^[N].NCalc=0 then T2:=@PHashCell(FF^[N].FTree)^.HData { ^PUserObject }
         else ObjByRef(@T2,PObjScan(FF^[N].FTree));
         MaySimple:=False;
        end;
        If P1^.Pars[N].UTFlag and utfByPar<>0 then begin
         {  - - }
         Inc(J);
         With CalcStack^[J] do begin
          CellType:=opFunc;
          If Op1=opObject then Aux:=nil else longint(Aux):=1;
          If b1 then Ref:=@fMailObjectBack else Ref:=@fPopObjectBack;
          T1:=@CalcStack^[M].T2; { 㤠  - }
          T2:=CalcStack^[M].T1;  {   }
          MaySimple:=False;
         end
        end
       end;

       opMultiVar:begin
        Q:=pointer(FF^[N].FTree);
        { - -  ᯨ᮪ । ࠭ ⨯ࠬ஢ }
        With CalcStack^[L] do begin
         CellType:=opFunc;
         If b1 then begin
          T1:=P; Ref:=@fCalcVirtClearMultiList;
         end
         else begin
          T1:=P^.FuncCalc; Ref:=@fCalcClearMultiList;
         end;
         T2:=pointer(N);
         MaySimple:=False;
        end;
        Dec(M);
        Dec(L);
        While Q<>nil do begin { 横  䠪᪨ । - }
         Inc(M);
         With CalcStack^[M] do begin
          MaySimple:=False;
          { । 祭 }
          CellType:=opFunc;
          longint(Aux):=longint(Q^.WhatExpr);
          If b1 then begin
           T1:=@P^.Pars[N].Hash; Ref:=@fPopVirtMParAddres;
          end
          else begin
           { 㤠 । }
           T1:=P^.Pars[N].Hash^.HData; { TCollection -ࠬ஢ }
           Ref:=@fPopMParAddres;
          end;
          {  । }
          case Q^.WhatExpr of
           wmpArrayMultiPar:
            If Q^.Aux=0 then { @Data 䠪- ᨢ/ }
             T2:=@PStructDef(PHashCell(Q^.Expr)^.HData)^.Data
            else ArByRef(@T2,Q^.Expr,False);
           wmpUserType1..wmpUserType2: begin
            If not Q^.ByValue then longint(Aux):=longint(Aux) or $8000;
            If Q^.Aux=0 then T2:=@PHashCell(Q^.Expr)^.ValueF
            else ParByRef(@T2,Q^.Expr);
           end;
           wmpObject: begin
            If Q^.Aux=0 then begin
             T2:=@PHashCell(Q^.Expr)^.HData; ResultP:=nil
            end
            else begin
             T2:=Q^.Expr; { PObjScan }
             longint(ResultP):=1
            end
           end;
           else
           If Q^.ByValue then begin
            T2:=@CalcStack^[Calcs+1].ResultF;
            BuildCalcStack(Q^.Expr,B) {  । - }
           end
           else begin
            If Q^.Aux=0 then T2:=@PHashCell(Q^.Expr)^.ValueF
            else ParByRef(@T2,Q^.Expr);
            longint(Aux):=longint(Aux) or $8000;
           end
          end
         end;
         Q:=Q^.Prev;
        end;
       end;
      end { case }
     end; { for N }

     {  -  ६ ᫮ -: ᫨ - 䠪.- ,
       祬 ᠭ,   ⮬ 㪠  맮 - । 
       뫪,  㦭 ந஢ 祩 CalcStack, ।祭
         -  - }
     For N:=j+1 to r do
      with CalcStack^[N] do CellType:=opConst;
    end; { If }
    Need:=True
   end;

   opFPar,opFUknown:begin
    CellType:=opFPar;
    T1:=@PHashCell(Tree^.WhatR)^.ValueF; { T1 = PFloat }
    Need:=True
   end;

   opStringConst:begin
    CellType:=opConst;
    ResultP:=Tree^.WhatR; { ResultP = PText }
    Need:=False;
   end;

   opSConst:begin
    CellType:=opConst;
    Need:=False;
    ResultP:=PHashCell(Tree^.WhatR)^.ValueP; { ResultP = PText }
   end;

   opSPar,opSUknown:begin
    CellType:=opConst;
    ResultP:=PHashCell(Tree^.WhatR)^.ValueP; { ResultP = PText }
    Need:=True;
   end;

   opStrConcat:begin  { ⥭ ப }
    CellType:=opFunc;
    K:=Tree^.Tail; Leaf(T2); b:=Need;
    K:=Tree^.Head; Leaf(T1); Need:=Need or b;
    Ref:=@fStrConcat;
    ResultP:=CurCompilator^.NewMem(TextTermSize);
   end;

   opRefPar,opRefString: begin
    CellType:=opFunc;
    Need:=True;
    with PFieldRef(Tree^.WhatR)^ do begin
     T1:=Obj; { PObjScan }
     longint(T2):=FieldNum; { #  }
    end;
    If Op=opRefString then Ref:=@fGetObjSValue else Ref:=@fGetObjFValue
   end;
  end; { case }
  MaySimple:=not Need
 end
end;

procedure TExpressionCalcer.Evaluate;
var i:word;
begin
 i:=Calcs;
 Repeat
  with CalcStack^[i] do
   case CellType of
    opFPar : FastMoveWord(T1^,ResultF,5);
    opFunc: TCalcFunc(Ref)(CalcStack^[i]);
   end;
  Dec(i)
 until i=0
end;

procedure TExpressionCalcer.Simplify;
var i:word;
begin
 i:=Calcs;
 Repeat
  with CalcStack^[i] do
   { ᫨ -  饭  ⨯ 樨=opFunc - - }
   If (CellType=opFunc) and MaySimple then begin
    TCalcFunc(Ref)(CalcStack^[i]);
    CellType:=opConst
   end;
  Dec(i)
 until i=0
end;

constructor TFormulaCalcer.Init(F:PFormula);
begin
 Inherited Init(F^.E);
 LHash:=F^.Loc;         {  ६    }
 ResAd:=@LHash^.ValueF; { 㤠  - - }
end;

procedure TFormulaCalcer.Evaluate;
begin
 Inherited Evaluate;
 ResAd^:=CalcStack^[1].ResultF; { १- -   ६ }
end;

constructor TRefFormulaCalcer.Init(F:PFormula; AIsFloat:boolean);
begin
 Inherited Init(F^.E);
 IsFloat:=AIsFloat;
 Field:=PFieldRef(F^.Loc)^;
end;

procedure TRefFormulaCalcer.Evaluate;
var P:PUserObject;
begin
 Inherited Evaluate;
 P:=ScanRefObject(Field.Obj);
 If IsFloat then P^.PutField(Field.FieldNum,CalcStack^[1].ResultF)
 else P^.PutRawField(Field.FieldNum,CalcStack^[1].ResultP)
end;

constructor TFuncPropCalcer.Init(F:PPropFormula);
var FloatFunc:boolean; P:PFunction;
begin
 P:=F^.Func;
 FloatFunc:=P2x2Function(P^.FuncCalc)^.GetFuncType<>ffStrFunc;
 If FloatFunc then FR:=New(PExpressionCalcer, Init(F^.RValue))
 else FR:=New(PStrExpressionCalcer, Init(F^.RValue));
 FL:=New(PExpressionCalcer, Init(F^.LValue));
 FL^.CalcStack^[1].CellType:=opConst; {  -  }
 With FL^.CalcStack^[P^.NParVars+2] do begin { 祩 맮 - }
  If Aux=nil then Ref:=@fAssignPropValue else Ref:=@fAssignVirtPropValue;
  RightVal:=@T2
 end;
end;

procedure TFuncPropCalcer.Evaluate;
begin
 Ppointer(RightVal)^:=FR^.Calculate;
 FL^.Evaluate;
end;

destructor TFuncPropCalcer.Done;
begin
 Dispose(FR,Done);
 Dispose(FL,Done);
 Inherited Done
end;

constructor TStrFormulaCalcer.Init(F:PFormula);
begin
 Inherited Init(F^.E);
 LHash:=F^.Loc;        {  ६    }
 StrAd:=LHash^.ValueP; { 㤠  - - }
end;

procedure TStrFormulaCalcer.Evaluate;
begin
 Inherited Evaluate;
 StrAd^:=CalcStack^[1].ResultP^; { १- -   ६ }
end;

constructor TArrayCalcer.Init(F:PArrayCell; What:integer);
begin
 with F^ do begin
  ByRef:=RefArr;
  If RefArr then with PFieldRef(F^.Loc)^ do begin
   MC:=Obj; { PObjScan }
   Field:=FieldNum;
  end
  else MC:=@PStructDef(Loc^.HData)^.Data;   { ^PMatrix }
  IndexC:=New(PExpressionCalcer, Init(Index));
  If What=0 then ValC:=New(PExpressionCalcer, Init(FTree))
  else ValC:=New(PStrExpressionCalcer, Init(FTree))
 end
end;

procedure TArrayCalcer.Evaluate;
type PM=^PMatrix;
var L:word;
begin
 L:=Round(IndexC^.Calculate^);
 If ByRef then
  PMatrix(ScanRefObject(PObjScan(MC))^.GetRawField(Field))^.Put(L, ValC^.Calculate)
 else PM(MC)^^.Put(L, ValC^.Calculate)
end;

destructor TArrayCalcer.Done;
begin
 Dispose(IndexC, Done);
 Dispose(ValC, Done)
end;

constructor TMatrixCalcer.Init(F:PArrayCell);
begin
 Inherited Init(F,0);
 Index2C:=New(PExpressionCalcer, Init(F^.Index2));
end;

procedure TMatrixCalcer.Evaluate;
type PM=^PMatrixF;
var L1,L2:word;
begin
 L1:=Round(IndexC^.Calculate^);
 L2:=Round(Index2C^.Calculate^);
 If ByRef then
  PMatrix(ScanRefObject(PObjScan(MC))^.GetRawField(Field))^.Put2(L1,L2, ValC^.Calculate)
 else PM(MC)^^.Put2(L1,L2, ValC^.Calculate)
end;

destructor TMatrixCalcer.Done;
begin
 Dispose(Index2C, Done);
 Inherited Done
end;

constructor TLogicCalcer.Init(ACalcs:word; Tree:PLogicTree);
begin
 GetMem(CalcStack, ACalcs*SizeOf(TCalcCell));
 Calcs:=0;
 BuildCalcStack(Tree)
end;

procedure TLogicCalcer.BuildCalcStack(Tree:PLogicTree);
var Op:OpsType; i,j:integer;
begin
 Inc(Calcs);
 With CalcStack^[Calcs] do begin
  Op:=Tree^.What;
  CellType:=Op;
  JmpInd:=0;

  Case Op of
   etBool: { - ࠢ }
    With PBoolExpression(Tree^.Left)^ do begin
     T1:=New(PExpressionCalcer, Init(Left));
     T2:=New(PExpressionCalcer, Init(Right));
     Ref:=GetBoolFunc(What)
    end;

   etObjBool:
    With PBoolExpression(Tree^.Left)^ do begin
     T1:=New(PObjRefCompareCalcer,Init(Left.FTree^.TermType,Right.FTree^.TermType,
      Left.FTree^.WhatR,Right.FTree^.WhatR));
     PObjRefCompareCalcer(T1)^.EqualOp:=What=rtE;
     Ref:=@fCompareObjRef
    end;

   etCompFunc:
    with Tree^ do begin
     T1:=New(PExpressionCalcer, Init(PExpression(Left)^));
     Ref:=GetBoolFunc(LogicOp)
    end;

   else { etLogic, .  }
    With Tree^ do begin
     If LogicOp<>ltNot then begin
      j:=Calcs+1;
      T2:=@CalcStack^[Calcs+1].ResultB;
      BuildCalcStack(Right);
     end;
     i:=Calcs+1;
     T1:=@CalcStack^[Calcs+1].ResultB;
     BuildCalcStack(Left);
     Ref:=GetLogicFunc(LogicOp);
     If ShortBoolEval and (LogicOp in [ltAnd,ltOr]) then
      with CalcStack^[i] do begin
       JmpInd:=j;
       JmpRel:=LogicOp=ltOr
      end;
    end
  end; { case }
 end
end;

procedure TLogicCalcer.Evaluate;
var i:word;
begin
 i:=Calcs;
 while i>0 do
  with CalcStack^[i] do begin
   TCalcFunc(Ref)(CalcStack^[i]);
   If (JmpInd<>0) and (JmpRel=ResultB) then begin
    CalcStack^[JmpInd].ResultB:=JmpRel;
    i:=JmpInd-1
   end
   else Dec(i)
  end
end;

function TLogicCalcer.CalculateB:boolean;
begin
 Evaluate;
 CalculateB:=CalcStack^[1].ResultB
end;

destructor TLogicCalcer.Done;
var i:word;
begin
 For i:=1 to Calcs do
  With CalcStack^[i] do
   Case CellType of
    etBool:begin
     Dispose(PCalcer(T1),Done);
     Dispose(PCalcer(T2),Done)
    end;
    etCompFunc,etObjBool: Dispose(PCalcer(T1),Done);
   end;
 FreeMem(CalcStack, Calcs*SizeOf(TCalcCell));
end;

constructor TIfCalcer.Init(P:PIfCycle);
begin
 Condition:=New(PLogicCalcer, Init(P^.LogCalcs,P^.Logic)); { ᫮ }
 BodyIf:=New(PBlockCalcer, Init(P^.BListIf,False)); { .  }
 If P^.BListElse=nil then BodyElse:=nil
 else {  Else }
  BodyElse:=New(PBlockCalcer, Init(P^.BListElse,False))
end;

procedure TIfCalcer.Evaluate;
begin
 If Condition^.CalculateB then BodyIf^.Evaluate
 else
  If BodyElse<>nil then BodyElse^.Evaluate
end;

destructor TIfCalcer.Done;
begin
 Dispose(Condition, Done);
 Dispose(BodyIf, Done);
 If BodyElse<>nil then Dispose(BodyElse, Done)
end;

constructor TWhileCalcer.Init(P:PWhileCycle);
begin
 Condition:=New(PLogicCalcer, Init(P^.LogCalcs,P^.Logic)); { ᫮ }
 Body:=New(PBlockCalcer, Init(P^.BList,False)); { ⥫ 横 }
end;

procedure TWhileCalcer.Evaluate;
begin
 CalcBreakState:=0;
 {  - ᫮   뫮 -஢ Break  Exit }
 While Condition^.CalculateB and (CalcBreakState and (BreakBit+ExitBit) =0) do
 begin
   asm
    mov ax,CalcBreakState
    test ax,ContinueBit   { ᫨   - Continue, }
    je @out               { 뢠 ᮮ-騩   CalcBreakState }
    and ax,not ContinueBit
    mov CalcBreakState,ax
@out:
   end;
   Body^.Evaluate
 end;
 { 頥  䫠 ஬ Exit }
 CalcBreakState:=CalcBreakState and ExitBit
end;

destructor TWhileCalcer.Done;
begin
 Dispose(Condition,Done);
 Dispose(Body,Done);
end;

constructor TBCECalcer.Init(AWhat:TRunControl);
begin
 What:=AWhat;
end;

procedure TBCECalcer.Evaluate;
begin
 case What of
  rbBreak:    CalcBreakState:=CalcBreakState or BreakBit;
  rbContinue: CalcBreakState:=CalcBreakState or ContinueBit;
  rbExit:     CalcBreakState:=CalcBreakState or (ExitBit+BreakBit);
 end
end;

constructor TBlockCalcer.Init(B:PBlockList; AGlobal:boolean);
const Breaks:array[etBreak..etExit] of TRunControl=(rbBreak,rbContinue,rbExit);
var i,j,k,BlocksCount:word; P:PBlockList; F:PFormulaCalcer;
begin
 Global:=AGlobal;
 j:=1; First:=1;

 With B^ do begin
  Count:=NBlocks;
  If not AGlobal then begin
   Inc(j,NStructDefs);
   Inc(Count,NStructDefs*2)
  end;
  BlocksCount:=NBlocks+NDefBlocks+j;
 end;
 Last:=Count; Calcs:=Count;

 GetMem(Operators, Count*SizeOf(pointer));
 FillChar(Operators^, Count*SizeOf(pointer), 0);

 P:=B^.Next;
 i:=j-1; k:=0;

 While j<BlocksCount do begin
   If CompError.Error<>0 then exit;
   Inc(i); Inc(j);
   Case P^.What of
    etFormula:
     Operators^[i]:=New(PFormulaCalcer, Init(P^.Expr));
    etStrFormula:
     Operators^[i]:=New(PStrFormulaCalcer, Init(P^.Expr));
    etIf:
     Operators^[i]:=New(PIfCalcer, Init(P^.Expr));
    etPrint:
     Operators^[i]:=New(PPrintCalcer, Init(P^.Expr));
    etArrayCell:
     If PArrayCell(P^.Expr)^.Index2.FTree=nil then
      Operators^[i]:=New(PArrayCalcer, Init(P^.Expr,0))
     else Operators^[i]:=New(PMatrixCalcer, Init(P^.Expr));
    etWhile:
     Operators^[i]:=New(PWhileCalcer, Init(P^.Expr));
    etStrArrayCell:
     Operators^[i]:=New(PArrayCalcer, Init(P^.Expr,1));
    etRefFormula,etRefStrFormula:
     Operators^[i]:=New(PRefFormulaCalcer, Init(P^.Expr,P^.What=etRefFormula));
    etProc:
     Operators^[i]:=New(PProcCalcer, Init(PExpression(P^.Expr)^));
    etFuncDef:
     If CompileFuncDef(P) then Dec(i) else exit;
    etCase:
     Operators^[i]:=New(PCaseCalcer, Init(P^.Expr));
    etFuncProp:
     Operators^[i]:=New(PFuncPropCalcer, Init(P^.Expr));
    etObjFormula:
     Operators^[i]:=New(PObjFormulaCalcer,Init(P^.Expr));
    etObjRefAssignFormula:
     Operators^[i]:=New(PObjRefFormulaCalcer,Init(P^.Expr));
    etBreak..etExit:
     Operators^[i]:=New(PBCECalcer, Init(Breaks[P^.What]));
    etArrayDef:
     If CompileArrayDef(P^.Expr) then Dec(i) else exit;
    etObjectDef:
     If DoObjectDef(P^.Expr) then Dec(i) else exit;
   end;
   P:=P^.Next
 end;

 If i<>Last then begin
  FastMoveWord(Operators^[Last+1], Operators^[i+1],(Count-Last)*(SizeOf(pointer) div 2));
  Dec(Calcs,k)
 end;
 Last:=Calcs+1-B^.NStructDefs
end;

function TBlockCalcer.DoObjectDef(Obj:pointer):boolean;
var P:PObjFieldDef; var i:integer;
begin
 DoObjectDef:=False;
 with P2x2Object(Obj)^ do begin
  For i:=0 to GetOwnFldDefCnt-1 do begin
   P:=GetOwnFldDef(i);
   case P^.FType of
    opUserFunc,opStringFunc,opUserProc,opParFunc,opParStrFunc,opParProc:
     with PFunction(P^.Data^.HData)^ do
      If FuncFlags and ffNotCreated<>0 then
       with CompError do begin
        Error:=teMethodNotDeclare;
        ErrorTxt:=P2x2Object(PMethodCalcer(FuncCalc)^.Obj2x2^.HData)^.Name+
         '.'+FuncName^.Name;
        cX:=1; cY:=2; exit
       end;
   end
  end;
  ProtectFields(True);
 end;
 DoObjectDef:=True
end;

function TBlockCalcer.CompileFuncDef(PBL:PBlockList):boolean;
var P:PFunction; FF:PUserFuncCalcer; BL:PBlockList;
begin
 P:=PBL^.Expr;
 {  ⥪ - }
 BL:=PBlockList(P^.FuncCalc);
 FF:=New(PUserFuncCalcer, Init(P));
 FF^.BuildBlockCalcer(BL);
 If P^.FuncFlags and ffMethod=0 then DefColl^.Insert(FF);
 CompileFuncDef:=CompError.Error=0
end;

function TBlockCalcer.CompileArrayDef(PS:PStructDef):boolean;
const maxword=$FFF0;
var P:PExpressionCalcer; S:extended; Lines,Cols,i,j:word; M:PMatrix; Q:PCellList;

 function GetDim(const Sz:TExpression; var Dim:word):boolean;
 begin
  P:=New(PExpressionCalcer, Init(Sz));
  S:=P^.Calculate^;
  Dispose(P, Done);
  If NotNumber(S) or (S<1) or (S>maxword) then
   with CompError,Sz do begin
    Error:=teInvArraySize;
    cX:=LocX; cY:=LocY;
    GetDim:=False; exit
   end;
  Dim:=Round(S);
  GetDim:=True
 end;

begin
 CompileArrayDef:=False;

 With PS^,PS^.ArrDef^ do begin
  { - ᫮ ப }
  Lines:=Size1;
  If Size2<>0 then Cols:=Size2 { ⠥ ᫮ ⮫殢 }
  else
   If MType and (GeneralM+StringM)<>0 then Cols:=1 else Cols:=Lines;

  If Extern then begin
  end
  else
   If Global then begin { ᠭ -  . ணࠬ }
    Case MType of
     GeneralM: M:=New(PHeapMatrixFG, Init(Lines,Cols));
     SimmM   : M:=New(PHeapMatrixFS, Init(Lines,Cols));
     DiagM   : M:=New(PHeapMatrixFD, Init(Lines,Cols));
     StringM : M:=New(PStrMatrix, Init(Lines,longint(Data)));
    end;
    DefColl^.Insert(M);
    J:=M^.Loc(Lines,Cols);
    PS^.Data:=M;
    Q:=CellList;

    For i:=1 to Cells do begin { - . - }
     If i>j then
      with CompError,Q^.F do begin
       Error:=teTooManyCells; cX:=LocX; cY:=LocY; exit
      end;

     Q:=Q^.Next;
     If MType=StringM then begin
      P:=New(PStrExpressionCalcer, Init(Q^.F));
      PStrMatrix(M)^.Put(i,Pstring(P^.Calculate));
      Dispose(P,Done)
     end
     else begin
      P:=New(PExpressionCalcer, Init(Q^.F));
      M^.Put(i,P^.Calculate);
      Dispose(P,Done)
     end;
    end;
    { ᫨ ᫮ . -  ࠧ, 㡫- ᫥ -   ⠢訥 }
    If (Cells>0) and (j>Cells) then
     If MType=StringM then M^.Fill(Cells+1,j,PString(M^.Get(Cells))^)
     else M^.Fill(Cells+1,j,PFloat(M^.Get(Cells))^)
   end
   else begin
    If MType=StringM then Cols:=longint(PS^.Data);
    Operators^[First]:=New(PMatrixAlloc, Init(Lines,Cols,PS));
    Inc(First);
    Operators^[Last]:=New(PMatrixDeAlloc, Init(PS));
    Dec(Last)
   end
 end;
 CompileArrayDef:=True
end;

procedure TBlockCalcer.Evaluate;
var CurBlock:word;
begin
 CurBlock:=1;
 While (CurBlock<=Calcs) and (CalcBreakState=0) do begin
  Operators^[CurBlock]^.Evaluate;
  Inc(CurBlock)
 end;
end;

destructor TBlockCalcer.Done;
var i:word;
begin
 For i:=1 to Calcs do
  If Operators^[i]<>nil then Dispose(Operators^[i], Done);
 FreeMem(Operators, Count*SizeOf(pointer));
end;

constructor TUserFuncCalcer.Init(AFunc:PFunction);
begin
 Inherited Init;
 F:=AFunc;
 AFunc^.FuncCalc:=@Self;
 HFunc:=F^.FuncName;
 BC:=nil
end;

procedure TUserFuncCalcer.BuildBlockCalcer(BL:PBlockList);
begin
 BC:=New(PBlockCalcer,Init(BL,False));
end;

procedure TUserFuncCalcer.Evaluate;
var i:word;
begin
 BC^.Evaluate;
 If CalcBreakState and ExitBit<>0 then
  with BC^ do
   For i:=Calcs downto Last do Operators^[i]^.Evaluate;
 CalcBreakState:=0
end;

function TUserFuncCalcer.GetFuncType:word;
begin
 case F^.FuncName^.TermType of
  opUserFunc: GetFuncType:=ffFloatFunc;
  opStringFunc: GetFuncType:=ffStrFunc;
  else GetFuncType:=ffProc
 end
end;

function TUserFuncCalcer.Calculate:PFloat;
begin
 Evaluate;
 case GetFuncType of
  ffFloatFunc: Calculate:=@HFunc^.ValueF;
  ffStrFunc: Calculate:=PFloat(HFunc^.ValueP);
  else Calculate:=nil
 end
end;

function TUserFuncCalcer.GetFuncDef:PFunction;
begin
 GetFuncDef:=F
end;

function TUserFuncCalcer.GetFieldNum(FieldName:TermString):integer;
var i:integer;
begin
 FieldName:=UpperCase(FieldName);
 With F^ do
  For i:=1 to NPars do
   If Pars[i].Hash^.Name=FieldName then begin
    GetFieldNum:=i; exit
   end;
 GetFieldNum:=-1
end;

destructor TUserFuncCalcer.Done;
begin
 If BC<>nil then Dispose(BC,Done);
 Inherited Done
end;

function TMethodCalcer.GetSelfObject:pointer;
begin
 GetSelfObject:=Obj2x2^.HData
end;

procedure TMethodCalcer.PushObjInstance(Obj:pointer);
begin
 Obj2x2^.HData:=Obj
end;

procedure TMethodCalcer.SetObjHash(H:PHashCell);
begin
 Obj2x2:=H
end;

constructor TMatrixAlloc.Init(ALines,ACols:word; P:PStructDef);
begin
 Lines:=ALines;
 Cols:=ACols;
 MType:=P^.MType;
 PData:=@P^.Data;
 Ppointer(PData)^:=nil
end;

procedure TMatrixAlloc.Evaluate;
var A:pointer;
begin
 Case MType of
  GeneralM: A:=New(PHeapMatrixFG, Init(Lines,Cols));
  SimmM   : A:=New(PHeapMatrixFS, Init(Lines,Cols));
  DiagM   : A:=New(PHeapMatrixFD, Init(Lines,Cols));
  StringM : A:=New(PStrMatrix, Init(Lines,Cols));
 end;
 Ppointer(PData)^:=A
end;

destructor TMatrixAlloc.Done;
begin
 If Ppointer(PData)^<>nil then Dispose(PMatrix(Ppointer(PData)^), Done)
end;

constructor TMatrixDeAlloc.Init(P:PStructDef);
begin
 PData:=@P^.Data;
end;

procedure TMatrixDeAlloc.Evaluate;
begin
 If Ppointer(PData)^<>nil then begin
  Dispose(PMatrix(Ppointer(PData)^), Done);
  Ppointer(PData)^:=nil
 end
end;

constructor TPrintCalcer.Init(B:PBlockList);
var i:word;
begin
 Count:=B^.NBlocks+1;
 GetMem(Operators, Count*SizeOf(pointer));
 FillChar(Operators^, Count*SizeOf(pointer), 0);
 Operators^[Count]:=New(PFlushLine,Init);
 For i:=1 to Count-1 do begin
  B:=B^.Next;
  Case B^.What of
   etFormula:    Operators^[i]:=New(PExpressionPrint, Init(B^.Expr));
   etStrFormula: Operators^[i]:=New(PStrFormulaPrint, Init(B^.Expr));
  end
 end;
end;

procedure TPrintCalcer.Evaluate;
var i:word;
begin
 For i:=1 to Count do Operators^[i]^.Evaluate
end;

destructor TPrintCalcer.Done;
var i:word;
begin
 For i:=1 to Count do
  If Operators^[i]<>nil then Dispose(Operators^[i], Done);
 FreeMem(Operators, Count*SizeOf(pointer));
end;

constructor TFlushLine.Init;
begin
 Inherited Init;
 Compiler:=PCalcer(CurCompilator)
end;

procedure TFlushLine.Evaluate;
begin
 PACompilator(Compiler)^.FlushPrintLine
end;

constructor TExpressionPrint.Init(F:PPrintRec);
begin
 Inherited Init;
 PE:=New(PExpressionCalcer, Init(F^.F));
 with F^ do begin
  TeF1:=F1; TeF2:=F2; TeExp:=Expo
 end;
end;

procedure TExpressionPrint.Evaluate;
var R:Float; s:string;
begin
 R:=PE^.Calculate^;
 If NotNumber(R) then
  If not TeExp and (TeF2=0) then s:='?' else s:=LPad('?',TeF1)
 else
  If TeExp then Str(R:TeF1,s) else Str(R:TeF1:TeF2,s);
 PACompilator(Compiler)^.Print(s)
end;

destructor TExpressionPrint.Done;
begin
 If PE<>nil then Dispose(PE, Done)
end;

constructor TStrFormulaPrint.Init(F:PPrintRec);
begin
 Inherited Init;
 PS:=New(PExpressionCalcer, Init(F^.F));
end;

procedure TStrFormulaPrint.Evaluate;
begin
 PS^.Evaluate;
 PACompilator(Compiler)^.Print(PS^.CalcStack^[1].ResultP^)
end;

destructor TStrFormulaPrint.Done;
begin
 If PS<>nil then Dispose(PS, Done)
end;

constructor TCaseCalcer.Init(P:PCaseOp);
var i:integer; Q:PCaseList; E:PExpressionCalcer;
begin
 Inherited Init;
 with P^ do begin
  WCase:=WhatCase;
  CaseCnt:=NCases;
  If WCase=etFormula then CaseExpression:=New(PExpressionCalcer,Init(CaseExpr))
  else CaseExpression:=New(PStrExpressionCalcer,Init(CaseExpr));
  If ElseBlock<>nil then BodyElse:=New(PBlockCalcer,Init(ElseBlock,False))
  else BodyElse:=nil;
  GetMem(FCases,CaseCnt*SizeOf(TCasesRec));
  Q:=Cases;
 end;

 i:=0;
 While Q<>nil do begin
  with FCases^[i] do begin
   If Q^.CaseBlock^.What=etCaseNext then NextJump:=True
   else begin
    NextJump:=False;
    CaseBlock:=New(PBlockCalcer,Init(Q^.CaseBlock,False));
   end;
   If WCase=etFormula then begin
    RelFunc:=FloatRelFuncs[Q^.RelWhat];
    E:=New(PExpressionCalcer,Init(Q^.CaseValue));
    If E^.ENeed then begin
     CFR.Calced:=0;
     CFR.FloatExpr:=E
    end
    else begin
     CFR.Calced:=1;
     CFR.FloatVal:=E^.Calculate^;
     Dispose(E,Done)
    end
   end
   else begin
    RelFunc:=StringRelFuncs[Q^.RelWhat];
    E:=New(PStrExpressionCalcer,Init(Q^.CaseValue));
    If E^.ENeed then begin
     CSR.Calced:=0;
     CSR.StrExpr:=PStrExpressionCalcer(E)
    end
    else begin
     CSR.Calced:=1;
     CSR.StrVal:=NewStr(PText(E^.Calculate)^);
     Dispose(E,Done)
    end
   end;
  end;
  Q:=Q^.Next;
  Inc(i)
 end;
end;

procedure TCaseCalcer.Evaluate;
var i:integer; V:Float; S:string; Equal,b:boolean;
begin
 b:=True;
 If WCase=etFormula then begin
  V:=CaseExpression^.Calculate^;
  i:=0;

  While i<CaseCnt do begin
   with FCases^[i] do begin
    If b then
     If CFR.Calced=1 then Equal:=TCompFloatFunc(RelFunc)(V,CFR.FloatVal) { V=CFR.FloatVal }
     else TCompFloatFunc(RelFunc)(V,CFR.FloatExpr^.Calculate^)
    else Equal:=True;
    If Equal then
     If NextJump then b:=False
     else begin
      CaseBlock^.Evaluate; exit
     end;
   end;
   Inc(i)
  end
 end
 else begin
  S:=PText(CaseExpression^.Calculate)^;
  i:=0;
  While i<CaseCnt do begin
   with FCases^[i] do begin
    If b then
     If CSR.Calced=1 then Equal:=TCompStrFunc(RelFunc)(PText(CSR.StrVal),s) {S=CSR.StrVal^}
     else Equal:=TCompStrFunc(RelFunc)(PText(CSR.StrExpr^.Calculate),s)
    else Equal:=True;
    If Equal then
     If NextJump then b:=False
     else begin
      CaseBlock^.Evaluate; exit
     end
   end;
   Inc(i)
  end
 end;
 { ᫨   -   case  ࠡ⠫ }
 If BodyElse<>nil then BodyElse^.Evaluate;
end;

destructor TCaseCalcer.Done;
var i:integer;
begin
 For i:=0 to CaseCnt-1 do
  with FCases^[i] do begin
   If CFR.Calced=1 then begin
    If WCase=etStrFormula then DisposeStr(CSR.StrVal)
   end
   else Dispose(CFR.FloatExpr,Done);
   If not NextJump then Dispose(CaseBlock,Done)
  end;
 FreeMem(FCases,CaseCnt*SizeOf(TCasesRec));
 If BodyElse<>nil then Dispose(BodyElse,Done);
 Dispose(CaseExpression,Done)
end;

constructor TObjFormulaCalcer.Init(F:PObjFormula);
begin
 ObjDef:=F^.LObj;
 LeftObj:=@F^.Loc^.HData;
 case F^.LWhatObj of
  opRefObject,opRefObjectRef: RefObj:=True;
  else RefObj:=False
 end;
 GetMem(CalcStack, F^.E.NCalc*SizeOf(TCalcCell));
 Calcs:=0;
 BuildCalcStack(F^.E.FTree);
end;

destructor TObjFormulaCalcer.Done;
begin
 FreeMem(CalcStack, Calcs*SizeOf(TCalcCell));
 Inherited Done
end;

procedure TObjFormulaCalcer.BuildCalcStack(Tree:PTermTree);
 procedure ObjByRef(a1:pointer; a2:PObjScan);
 begin
  Inc(Calcs);
  with CalcStack^[Calcs] do begin
   CellType:=opObject;
   T1:=a1; T2:=a2
  end
 end;

var Op:OpsType; K:PTermTree;
begin
 Inc(Calcs);
 With CalcStack^[Calcs] do begin
  Op:=Tree^.TermType;

  Case Op of
   opObject:begin
    CellType:=opFUknown;
    T1:=@PHashCell(Tree^.WhatR)^.HData { ^PUserObject }
   end;

   opRefObject:begin
    CellType:=opFPar;
    T1:=Tree^.WhatR { PObjScan }
   end;

   opFunc1:begin
    CellType:=opFunc1;
    K:=Tree^.Head;
    If K^.TermType=opObject then T1:=@PHashCell(K^.WhatR)^.HData
    else ObjByRef(@T1,K^.WhatR);
    longint(Aux):=Tree^.What;
   end;

   opFunc2:begin
    CellType:=opFunc2;
    K:=Tree^.Head;
    If K^.TermType=opObject then T1:=@PHashCell(K^.WhatR)^.HData else ObjByRef(@T1,K^.WhatR);
    K:=Tree^.Tail;
    If K^.TermType=opObject then T2:=@PHashCell(K^.WhatR)^.HData else ObjByRef(@T2,K^.WhatR);
    longint(Aux):=Tree^.What;
   end;
  end; { case }
 end
end;

procedure TObjFormulaCalcer.Evaluate;
var Obj:PUserObject; i:integer;
begin
 If RefObj then Obj:=ScanRefObject(PObjScan(LeftObj))
 else Obj:=Ppointer(LeftObj)^;
 For i:=Calcs downto 1 do
  With CalcStack^[i] do
   case CellType of
    opFUknown: Obj^.Assign(Ppointer(T1)^);
    opFPar: Obj^.Assign(ScanRefObject(T1));
    opObject: Ppointer(T1)^:=ScanRefObjectAdr(T2);
    opFunc1: P2x2Object(ObjDef)^.OnCalcFunc(Ppointer(T1)^,Obj,longint(Aux));
    opFunc2:
     P2x2Object(ObjDef)^.OnCalcOperator(Ppointer(T1)^,Ppointer(T2)^,Obj,longint(Aux));
   end;
end;

constructor TObjRefCalcer.Init(LWObj,RWObj:OpsType; OLoc:PHashCell; E:pointer);
begin
 case LWObj of
  opRefObject,opRefObjectRef: begin
   LRefObj:=True; LeftObj:=pointer(OLoc) { PObjScan }
  end
  else begin
   LRefObj:=False; LeftObj:=@OLoc^.HData { ^PUserObject }
  end
 end;
 case RWObj of
  opRefObject,opRefObjectRef: begin
   RRefObj:=True; RightObj:=E { PObjScan }
  end
  else begin
   RRefObj:=False; RightObj:=@PHashCell(E)^.HData { ^PUserObject }
  end
 end;
end;

function TObjRefCompareCalcer.CalculateB:boolean;
var pl,pr:pointer;
begin
 If RRefObj then pr:=ScanRefObject(RightObj) else pr:=Ppointer(RightObj)^;
 If LRefObj then pl:=ScanRefObject(LeftObj) else pl:=Ppointer(LeftObj)^;
 If EqualOp then CalculateB:=pl=pr else CalculateB:=pl<>pr
end;

constructor TObjRefFormulaCalcer.Init(F:PObjFormula);
begin
 with F^ do Inherited Init(LWhatObj,RWhatObj,Loc,F^.E.FTree)
end;

procedure TObjRefFormulaCalcer.Evaluate;
var pl,pr:ppointer;
begin
 If RRefObj then pr:=ScanRefObjectAdr(RightObj) else pr:=RightObj;
 If LRefObj then pl:=ScanRefObjectAdr(LeftObj) else pl:=LeftObj;
 pl^:=pr^
end;

function T2x2Function.GetFuncDef:PFunction;
begin end;

function T2x2Function.GetFuncType:word;
begin end;

function T2x2Function.ParsDefine:boolean;
begin
 ParsDefine:=True
end;

procedure T2x2Function.ParTypes(var PTypes:array of T2x2Type; var ByValue:array of boolean);
{ 頥 ᠭ 㬥⮢ 㭪樨 }
var i:integer; c:word; b:boolean;
begin
 With GetFuncDef^ do
  For i:=1 to NPars do begin
   b:=True;
   case Pars[i].TermType of
    opFUknown: c:=dctFloat;
    opFPar: begin c:=dctFloat; b:=False; end;
    opArrayVar: c:=dctArray;
    opStrArrVar: c:=dctStrArray;
    opSPar: begin c:=dctString; b:=False; end;
    opSUknown: c:=dctString;
    opParFunc: c:=dctFunc;
    opParProc: c:=dctProc;
    opUserVar,opUserPar: begin
     c:=Pars[i].Hash^.What; b:=Pars[i].TermType=opUserVar
    end;
    opObject: begin
     c:=dctObject; b:=Pars[i].UTFlag and utfByPar=0 {c:=Pars[i].Hash^.What;}
    end;
    opObjectRef: begin
     c:=dctObjRef; b:=Pars[i].UTFlag and utfByPar=0
    end;
    opObjectType: c:=dctObjType
   end;
   PTypes[i-1]:=c;
   ByValue[i-1]:=b
  end
end;

function T2x2Function.ObjectArgType(ParNum:integer):PObject;
{  ࠬ ⨯ ꥪ/ꥪ⭠ 뫪 頥 ⥫ ꥪ P2x2Object }
begin
 with GetFuncDef^ do
  If (ParNum>0) and (ParNum<=NPars) then ObjectArgType:=pointer(Pars[ParNum].Hash^.ValueP)
  else ObjectArgType:=nil
end;

function T2x2Function.FuncParArgs(ParNum:integer):string;
{  楤୮ ࠬ - 頥 ⨯  㬥⮢ }
var PF:PFunction; s:string; i:integer;
begin
 s:='';
 with GetFuncDef^ do
  If (ParNum>0) and (ParNum<=NPars) then
   case Pars[ParNum].TermType of
    opParFunc,opParProc: begin
     PF:=PFunction(Pars[ParNum].Hash^.HData);
     For i:=1 to PF^.NPars do
      With PF^.Pars[i] do
       case TermType of
        opFPar: s:=s+'@';
        opFUknown: s:=s+'*';
        opSUknown: s:=s+'s';
        opSPar: s:=s+'S';
        opArrayVar: s:=s+'A';
       end;
    end;
    else s:='?'
   end;
 FuncParArgs:=s
end;

procedure T2x2Function.SetParValue(ParNum:integer; var AValue);
{ ⠭ - ࠬ }
var Fn:PFunction;
begin
 With GetFuncDef^ do
  If (ParNum>0) and (ParNum<=NPars) then with Pars[ParNum] do
  case TermType of
   opFUknown,opFPar,opUserVar,opUserPar: Hash^.ValueF:=Float(AValue);
   opArrayVar,opStrArrVar: PStructDef(Hash^.HData)^.Data:=PMatrix(AValue);
   opSUknown,opSPar: Hash^.ValueP^:=string(AValue);
   opParFunc,opParProc:begin
    Fn:=P2x2Function(AValue)^.GetFuncDef;
    FastMoveWord(Fn^,PFunction(Hash^.HData)^,
     (SizeOf(_TFunction)+Fn^.NPars*SizeOf(TFuncPars)) div 2);
   end;
   opObject: PUserObject(Hash^.HData)^.Assign(PUserObject(AValue));
   opObjectRef: PUserObject(Hash^.HData):=PUserObject(AValue);
   opObjectType: P2x2Object(Hash^.HData):=P2x2Object(AValue);
  end;
end;

procedure T2x2Function.SetRawParValue(ParNum:integer; AValue:pointer);
{ ⠭ - ࠬ }
var Fn:PFunction;
begin
 With GetFuncDef^ do
  If (ParNum>0) and (ParNum<=NPars) then with Pars[ParNum] do
  case TermType of
   opFUknown,opFPar,opUserVar,opUserPar: Hash^.ValueF:=PFloat(AValue)^;
   opArrayVar,opStrArrVar: PStructDef(Hash^.HData)^.Data:=PMatrix(AValue);
   opSUknown,opSPar: Hash^.ValueP^:=Pstring(AValue)^;
   opParFunc,opParProc:begin
    Fn:=P2x2Function(AValue)^.GetFuncDef;
    FastMoveWord(Fn^,PFunction(Hash^.HData)^,
     (SizeOf(_TFunction)+Fn^.NPars*SizeOf(TFuncPars)) div 2);
   end;
   opObject: PUserObject(Hash^.HData)^.Assign(PUserObject(AValue));
   opObjectRef: PUserObject(Hash^.HData):=PUserObject(AValue);
   opObjectType: P2x2Object(Hash^.HData):=P2x2Object(AValue);
  end;
end;

procedure T2x2Function.GetParValue(ParNum:integer; var AValue);
{ 頥 - ࠬ }
begin
 With GetFuncDef^.Pars[ParNum] do
  case TermType of
   opFUknown,opFPar,opUserVar,opUserPar: Float(AValue):=Hash^.ValueF;
   opArrayVar,opStrArrVar: PMatrix(AValue):=PStructDef(Hash^.HData)^.Data;
   opSUknown,opSPar: string(AValue):=Hash^.ValueP^;
   opParFunc,opParProc:
    P2x2Function(AValue):=P2x2Function(PFunction(Hash^.HData)^.FuncCalc);
   opObject: PUserObject(PUserObject(AValue))^.AssignSmart(Hash^.HData);
   opObjectRef: PUserObject(AValue):=PUserObject(Hash^.HData);
   opObjectType: P2x2Object(AValue):=P2x2Object(Hash^.HData);
  end;
end;

function T2x2Function.GetRawParValue(ParNum:integer):pointer;
{ 頥 - ࠬ }
begin
 With GetFuncDef^.Pars[ParNum] do
  case TermType of
   opFUknown,opFPar,opUserVar,opUserPar: GetRawParValue:=@Hash^.ValueF; { PFloat }
   opArrayVar,opStrArrVar: GetRawParValue:=PStructDef(Hash^.HData)^.Data; { PMatrix }
   opSUknown,opSPar: GetRawParValue:=Hash^.ValueP; { PText }
   opParFunc,opParProc:GetRawParValue:=P2x2Function(PFunction(Hash^.HData)^.FuncCalc); { P2x2Function }
   opObject,opObjectRef,opObjectType: GetRawParValue:=Hash^.HData; { PUserObject,P2x2Object }
  end;
end;

function T2x2Function.GetSelfObject:pointer;
begin
 GetSelfObject:=nil
end;

procedure T2x2Function.PushObjInstance(Obj:pointer);
begin end;

function T2x2Function.ParCount:integer;
{ - 㬥⮢ }
begin
 ParCount:=GetFuncDef^.NPars
end;

function T2x2Function.Equal(AFunc:PFunction):boolean;
{ ஢ઠ ⭮ -  (AFunc)  ⭮襭 ⨯ -,
  -  ⨯ - }
var b:boolean; i:integer;
begin
 b:=True;
 with GetFuncDef^ do
  If (NPars<>AFunc^.NPars) or (MinFactArgs<>AFunc^.MinFactArgs) or
  ((FuncFlags xor AFunc^.FuncFlags) and not
   (ffSimpleIfAllConst or ffMethod or ffPersistant or ffNotCreated)<>0) then b:=False
  else
   { ᢥ塞 ࠬ }
   For i:=1 to NPars do
    If (Pars[i].TermType<>AFunc^.Pars[i].TermType) or
       (Pars[i].UTFlag<>AFunc^.Pars[i].UTFlag) then
    begin
     b:=False; break
    end;
 Equal:=b
end;

function T2x2Function.FunctionName:string;
begin
 FunctionName:=HFunc^.Name
end;

function T2x2Function.CallInherit(var Res):boolean;
var O:PUserObject; P:P2x2Function; Fn:PFunction; i:integer;
begin
 CallInherit:=False;
 O:=GetSelfObject;
 If O=nil then exit;
 Fn:=GetFuncDef;
 If Fn^.FuncFlags and ffVirtual=0 then exit;
 P:=O^.GetInheritMethod(FunctionName);
 If P=nil then exit;
 P^.PushObjInstance(O);
 For i:=1 to Fn^.NPars do P^.SetRawParValue(i,GetRawParValue(i));
 case GetFuncType of
  ffFloatFunc: string(Res):=PText(P^.Calculate)^;
  ffStrFunc: Float(Res):=P^.Calculate^;
  else P^.Evaluate
 end;
 CallInherit:=True
end;

procedure TACompilator.Print(Var S:string);
begin end;
procedure TACompilator.FlushPrintLine;
begin end;
procedure TACompilator.ReadyPrint;
begin end;
function TACompilator.GetFuncAdres(What:word):pointer;
begin end;

function TACompilator.NewMem(Size:word):pointer;
var P:PMemRec;
begin
 If Size and 1<>0 then Inc(Size);
 with CurMem^ do
  If CurSize+Size>MemRecSize then begin
   New(P);
   P^.Next:=nil;
   P^.CurSize:=0;
   CurMem^.Next:=P;
   CurMem:=P
  end
  else P:=CurMem;
 NewMem:=@P^.MemAdr[P^.CurSize];
 Inc(P^.CurSize,Size)
end;

function TACompilator.NewMemTmp(Size:word):pointer;
var P:PMemRec;
begin
 If Size and 1<>0 then Inc(Size);
 with CurMemTmp^ do
  If CurSize+Size>MemRecSize then begin
   New(P);
   P^.Next:=nil;
   P^.CurSize:=0;
   CurMemTmp^.Next:=P;
   CurMemTmp:=P
  end
  else P:=CurMemTmp;
 NewMemTmp:=@P^.MemAdr[P^.CurSize];
 Inc(P^.CurSize,Size)
end;

procedure TACompilator.DisposeMem;
var P,P1:PMemRec;
begin
 P:=Mem2x2;
 while P<>nil do begin
  P1:=P^.Next;
  Dispose(P);
  P:=P1
 end;
 Mem2x2:=nil
end;

procedure TACompilator.DisposeMemTmp;
var P,P1:PMemRec;
begin
 P:=Mem2x2Tmp;
 while P<>nil do begin
  P1:=P^.Next;
  Dispose(P);
  P:=P1
 end;
 Mem2x2Tmp:=nil
end;

constructor TACompilator.Init;
begin
 Inherited Init;
 New(Mem2x2);
 CurMem:=Mem2x2;
 with Mem2x2^ do begin
  Next:=nil;
  CurSize:=0
 end;
 New(Mem2x2Tmp);
 CurMemTmp:=Mem2x2Tmp;
 with Mem2x2Tmp^ do begin
  Next:=nil;
  CurSize:=0
 end;
end;

destructor TACompilator.Done;
begin
 DisposeMem;
 DisposeMemTmp;
 Inherited Done;
end;

procedure TACompilator.MapError(Var Xe,Ye:word);
begin end;

procedure TACompilator.ErrorJump(CheckEnd:integer; Xe,Ye:word; Error:word);
begin
 MapError(Xe,Ye);
 ErrorX:=Xe; ErrorY:=Ye;
 If CheckEnd<>0 then
  With TopTerm^ do
   If TermType=opEndData then begin
    ErrorX:=X; ErrorY:=Y; TransError:=teUnexpectedEnd;
    LongJump(JumpPoint)
   end;
 TransError:=Error;
 LongJump(JumpPoint)
end;

procedure ValidName(Var Name:string; Var Error:integer; Var ErrorPos:word);
begin
 If Length(Name)>MaxTermLen then begin
  Error:=teInvNameLen; ErrorPos:=1; exit
 end;
 If IsNumber(Name[1]) then begin
  Error:=teFirstNumber; ErrorPos:=1; exit
 end;
 ErrorPos:=GetHashKey(Name);
 If ErrorPos<>0 then Error:=teIncorrectChar else Error:=0
end;

procedure PrepareToSwitchModule(var SwitchBuf:TSwitchBuffer; ModType:TModuleType);
begin
 with SwitchBuf do begin
  SCompError:=CompError;
  SDefColl:=DefColl;
  SCurComp:=CurCompilator;
 end
end;

procedure SwitchModuleBack(var SwitchBuf:TSwitchBuffer; ModType:TModuleType);
begin
 with SwitchBuf do begin
  CompError:=SCompError;
  DefColl:=SDefColl;
  CurCompilator:=PACompilator(SCurComp);
 end
end;

End.
