{ (c) Copyright 1995,1997 㭨 .. bunin@mes.djug.pyatigorsk.su }
Unit UserFunc; { প - - }
{$B-,F+,A+,N+,R-,S-,V-,I-,G+,X+,T-}

Interface
Uses Hash2x2,Def2x2,Calcer,Objects,x1;

Type
 HashArray=array[1..MaxFuncPars] of THashCell;
 PHashArray=^HashArray;

 PMultiFact=^TMultiFact; { ⥫ 䠪.ࠬ ⨯- }
 TMultiFact=record
  What:TMultiExprType; { ⨯ }
  ByValue:boolean;     { True ᫨ ।  祭 }
  Value:pointer        { 㪠⥫   }
 end;

 P2x2Object=^T2x2Object;
 PUserObject=^TUserObject;
 PFuncObject=^TFuncObject;

 TOnEvaluate=procedure(Func:PFuncObject);

 { ࠪ ᫨⥫ - - }
 TFuncObject=object(T2x2Function)
  F:TFunction; { ⥫ - }
  Name:TermString; {  - }
  {  ⮤ - 頥  ꥪ }
  function GetSelfObject:pointer;virtual;
  { ।  ⮤  ꥪ }
  procedure PushObjInstance(Obj:pointer);virtual;
  { 頥 ⥫ 㭪樨 }
  function GetFuncDef:PFunction;virtual;
  { 頥  㭪樨 }
  function FunctionName:string;virtual;
  {   㭪/⮤  ᪮쪮 ஢/ꥪ⮢ }
  procedure SetPersistant;
  procedure SetOnEvaluate(AOnEvaluate:TOnEvaluate);
  procedure Evaluate;virtual;
  constructor Init;
  destructor Done;virtual;
  { 㦥 ⮤ }
  { ॣ -   }
  function Register(Hash:PTermhash):boolean;virtual;
  function ParsDefine:boolean;virtual;
 private
  SubrType:word;
  CurCell:byte;  { ⥪.  - }
  FObject2x2:PUserObject; {  ⮤ -  ꥪ }
  FOnEvaluate:TOnEvaluate;
 end;

 { ᫨⥫ 楤 - }
 PUserProc=^TUserProc;
 TUserProc=object(TFuncObject)
  constructor Init(const AName:TermString; ArgCount:word); { , ᫮ - }
  {  ᠭ - ⨯ Float, IsVar=True, ᫨ । 
    뫪. 頥  - }
  function InsertFloatPar(IsVar:boolean):PFloat;
  {  ᠭ - ⨯ String, IsVar=True, ᫨ । 
    뫪. 頥  ப }
  function InsertStrPar(IsVar:boolean):PText;
  {  ᠭ - ⨯ Array, 頥 ,  ஬
    㤥 । - PMatrix }
  function InsertArrayPar:Ppointer;
  function InsertStrArrayPar:Ppointer;
  function InsertAnyArrayPar:Ppointer;
  {  ᠭ - ⨯ ⨯ࠬ }
  procedure InsertMultiPar;
  {  ᠭ - ⨯ 짮⥫, TypeId - 䨪 ⨯
    짮⥫, IsVar=True, ᫨ ।  뫪. 頥  - }
  function InsertUserTypePar(TypeId:TUserVarType; IsVar:boolean):PFloat;
  {  ᠭ - ⨯ ꥪ }
  function InsertObjectPar(Obj2x2:P2x2Object; IsVar:boolean):PUserObject;
  {  ᠭ - ⨯ ꥪ⭠ 뫪 }
  function InsertObjectRefPar(Obj2x2:P2x2Object; IsVar:boolean):Ppointer;
  {  ᠭ - ⨯ ꥪ⭠ 뫪 ⨯ TObject }
  function InsertAnyObjectPar:Ppointer;
  {  ᠭ - ⨯ ꥪ ⨯ }
  function InsertObjectTypePar:Ppointer;
  {  ᠭ - ⨯ Polinom, 頥 ,  ஬
    㤥 । - PPolinom }
  function InsertPolinomPar:Ppointer;
  {  ᠭ - ⨯ Func, ParTypes-ப, 뢠
    ⨯ - ( ᨬ -  -):
    '*' - Float
    '@' - Float  뫪
    'A' - Array
    'O' - Polinom }
  procedure InsertFuncPar(const ParamTypes:string);
  procedure InsertProcPar(const ParamTypes:string);
  { - । -  맮 ---;
    Par - 浪  -  ᯨ᪥ -, Data - ᨢ 㪠-
     । -:
      Float        : 㪠- ⨯ PFloat;
      Array,Polinom: 㪠- ⨯ PMatrix }
  function CallParFunc(ParNum:word; Var Data):Float;
  { ᫮ 䠪᪨ ࠬ஢  ࠬ ParNum }
  function NumOfMultiArgs(ParNum:integer):integer;
  { ᠭ 䠪.- #ArgNum ࠬ ParNum }
  procedure MultiArgDesc(ParNum,ArgNum:integer; var ArgType:TMultiExprType; var AByValue:boolean);
  { 㪠⥫  祭 䠪.- #ArgNum ࠬ ParNum }
  function MultiArgValue(ParNum,ArgNum:integer):pointer;
  function GetFuncType:word;virtual;
  destructor Done;virtual;
  { 㦥 ⮤ }
  { 頥 ᯨ᮪ ⨯ࠬ஢ }
  procedure ClearMultiList(ParNum:integer);
 private
  Hashes:PHashArray; {  - }
  function InsertArray(What:word):Ppointer;
  function InsertArgument(IsVar,NotSimp:boolean; t1,t2:word):boolean;
  procedure InsertSubrPar(const ParamTypes:string; What:word);
 end;

 { ᫨⥫ 㭪樨 - }
 PUserFunc=^TUserFunc;
 TUserFunc=object(TUserProc)
  FactArgCount:integer; { 䠪.- -, 㪠  맮 - }
  constructor Init(const AName:TermString; ArgCount:byte; Options:TFuncOptions);
  { । ᫥ - Res^ -  맢襥  ࠦ-.
     易⥫쭮 -  ⮤ Evaluate. }
  procedure SetResult(Res:PFloat);
  procedure AssignResult(Res:pointer);virtual;
  {  㭪樨-property ᢠ  .祭 Value }
  procedure AssignValue(Value:pointer);virtual;
  {  쭮 ⨬ - - }
  procedure SetMinArgCount(MinCount:integer);
  function Calculate:PFloat;virtual;
  function GetFuncType:word;virtual;
 end;

 { - ப - - }
 PUserStrFunc=^TUserStrFunc;
 TUserStrFunc=object(TUserFunc)
  procedure SetResult(Res:PText);
  function Calculate:PFloat;virtual;
  function GetFuncType:word;virtual;
 end;

 PObjFieldDef=^TObjFieldDef; { ⥫  ꥪ }
 TObjFieldDef=record
  FName:TermString; {  }
  FType:OpsType;    { ⨯ }
  Num:integer;      {  }
  FldFlags:word;    { 䫠 }
  case integer of
   0: (Data:PHashCell); {  ⮤ - ,  ꥪ⮢ - P2x2Object }
   1: (ACols,ALines:word); {  ᨢ - 砫쭠 ࠧ୮ }
   2: (UType:integer); { - ⨯ - }
 end;

 {  ⥫  ꥪ }
 PObjFieldColl=^TObjFieldColl;
 TObjFieldColl=object(TCollection)
  procedure FreeItem(Item:pointer);virtual;
 private
  function FindByNum(SNum:integer):PObjFieldDef;
  function FindByName(const IdName:string):integer;
 end;

 TOnCreate2x2Object=function(Obj2x2:P2x2Object):PUserObject;
 TOnCalcFunc=procedure(Par1,Res:PUserObject; AFunction:TUnar);
 TOnCalcOperator=procedure(Par1,Par2,Res:PUserObject; AOperator:TMOOperations);
 TOnDestroyObject=procedure(Obj:PUserObject);

 { ⥫ ⨯ ꥪ }
 T2x2Object=object(TObject)
  Name:TermString; {  ⨯ }
  ObjId:TObjVarType; { - ⨯ }
  OnCalcFunc:TOnCalcFunc;
  OnCalcOperator:TOnCalcOperator;
  constructor Init(ObjName:TermString; AObjId:TObjVarType; InheritObj:P2x2Object);
  function AddField(const FieldName:Termstring; FieldType:TObjFieldType; FldOption:TFldOption):boolean;
  function AddObjectRefField(const FieldName:Termstring; ObjDef:P2x2Object; FldOption:TFldOption):boolean;
  function AddObjectField(const FieldName:Termstring; ObjDef:P2x2Object; FldOption:TFldOption):boolean;
  procedure DefineArray(FieldNo:integer; Lines,Cols:integer);
  function AddMethod(MethodCalcer:P2x2Function; MethodOption:TFldOption):integer;
  function FindField(IdName:string):integer;
  procedure SetOnCreate(CreateFunc:TOnCreate2x2Object);
  procedure SetOnCalcFunc(CalcFunc:TOnCalcFunc);
  procedure SetOnCalcOperator(CalcOperator:TOnCalcOperator);
  procedure SetOnDestroy(DestroyFunc:TOnDestroyObject);
  procedure EnableOperator(AOperators:TOperations);
  procedure EnableFunction(AFunctions:TUnarFuncs);
  function IsDefOperator(AOperator:TMOOperations):boolean;
  function IsDefFunction(AFunction:TUnar):boolean;
  function GetFieldCount:integer;
  function GetMethodCount:integer;
  function ObjectIsParent(AObjId:TObjVarType):boolean;
  destructor Done;virtual;
  { 㦥 ⮤ }
  function AddMethodPrim(MethDef:PFunction; const MName:TermString; MethodOption:TFldOption):integer;
  function FindIdent(const IdName:TermString; var FNum:integer; var P:PObjFieldDef):integer;
  procedure ProtectFields(On:boolean);
  function GetOwnFldDefCnt:integer;
  function GetOwnFldDef(Num:integer):PObjFieldDef;
  function FindByNum(SNum:integer):PObjFieldDef;
  function FindByName(const IdName:string):integer;
  function GetProtectSwitch:boolean;
  procedure SetWhoCreate(WC:pointer);
 private
  Fields:PObjFieldColl; { protected }
  OnCreate2x2Object:TOnCreate2x2Object;
  OnDestroy:TOnDestroyObject;
  FieldCnt,MethodCnt:integer;
  CurMethod:integer;
  Operators:TOperations;
  Functions:TUnarFuncs;
  InheritObject:P2x2Object;
  FInitCreated:boolean;
  ProtectedLock:boolean;
  WhoCreate:pointer;
  function GetFieldDef(Num:integer):PObjFieldDef;
  function FindMethod(MethodNum:integer):PFunction;
  function AddFieldPrim(FieldName:Termstring; FieldType:TObjFieldType; AData:pointer;
   FldOption:TFldOption):boolean;
  function ExistObjField(O:P2x2Object):boolean;
 end;

 HashpArray=array[1..10] of PHashCell;
 PHashpArray=^HashpArray;

 TUserObject=object(TObject)
  ObjTag:longint;
  UserData:pointer;
  destructor Done;virtual;
  constructor Init(Obj2x2:P2x2Object);
  procedure PutField(FieldNo:integer; Var AValue);
  procedure GetField(FieldNo:integer; Var AValue);
  function GetRawField(FieldNo:integer):pointer;
  procedure PutRawField(FieldNo:integer; AValue:pointer);
  procedure Assign(SrcObj:PUserObject);
  procedure AssignSmart(SrcObj:PUserObject);
  function GetObjDef:P2x2Object;
  function GetMethod(MethodName:TermString):P2x2Function;
  function GetInheritMethod(MethodName:TermString):P2x2Function;
  function ObjectIsParent(AObjId:TObjVarType):boolean;
  { 㦥 ⮤ }
  procedure AssignBackward(SrcObj:PUserObject);
  function GetArrayRef(FieldNo:integer):PStructDef;
  function GetObjectRef(FieldNo:integer):pointer;
  function GetFieldHash(FNum:integer):PHashCell;
  function FindVirtualMethod(MethodNum:integer):PFunction;
  procedure AutoCreatedOff;
  procedure CallCreate;
 private
  FObjDef:P2x2Object;
  FFieldCnt,FMethodCnt:integer;
  Hashes:PHashpArray; {  - }
  AutoCreated:boolean;
 end;

var User2x2TObject:P2x2Object;

Type

 PFuncCall=^TFuncCall;
 TFuncCall=record
  Func:PFunction;
  CallFlags:integer;
  FuncIndex:integer;
  CallObj:pointer
 end;

function CreateObjInstance(ObjDef:P2x2Object):PUserObject;
procedure DoneUser;
procedure CreateTObject(var TObj:P2x2Object);
function CreateOCProc:PFuncObject;

Implementation
Uses MyString,MatrDef,Diffy,Prog2x2;

Type

 PInitProc=^TInitProc;
 TInitProc=object(TUserProc)
  procedure Evaluate;virtual;
 end;

 PGetObjTypeName=^TGetObjTypeName;
 TGetObjTypeName=object(TUserStrFunc)
  procedure Evaluate;virtual;
 end;

 PGetObjTypeId=^TGetObjTypeId;
 TGetObjTypeId=object(TUserFunc)
  procedure Evaluate;virtual;
 end;

 PObjectFree=^TObjectFree;
 TObjectFree=object(TUserProc)
  procedure Evaluate;virtual;
 end;

 PCreateObject=^TCreateObject;
 TCreateObject=object(TUserProc)
  procedure Evaluate;virtual;
 end;

const
 CreateMethodNum=4;
 DestroyMethodNum=5;

var
 ObjInitMethod:PInitProc;
 ObjGetNameMethod:PGetObjTypeName;
 ObjGetIdMethod:PGetObjTypeId;
 ObjFreeMethod:PObjectFree;

constructor TFuncObject.Init;
begin
 Inherited Init;
 New(HFunc);
 FillChar(F,SizeOf(TFunction),0); { NParVars:=0; }
 With F do begin
  FuncCalc:=@Self; { ᫨⥫ }
  FuncFlags:=GetFuncType or ffAsMethodEnable; {  㦨 ⮤ }
  If FuncFlags and ffStrFunc<>0 then New(HFunc^.ValueP); { 뤥塞   १- }
  FuncName:=HFunc; {  }
  HFunc^.HData:=@F;
  HFunc^.What:=0; { ਧ,    ⮤ }
 end;
 FOnEvaluate:=nil
end;

destructor TFuncObject.Done;
begin
 If GetFuncType=ffStrFunc then Dispose(HFunc^.ValueP);
 Dispose(HFunc);
 Inherited Done
end;

procedure TFuncObject.SetOnEvaluate(AOnEvaluate:TOnEvaluate);
begin
 FOnEvaluate:=AOnEvaluate
end;

procedure TFuncObject.Evaluate;
begin
 If Assigned(FOnEvaluate) then FOnEvaluate(@Self)
end;

function TFuncObject.GetSelfObject:pointer;
begin
 If F.FuncFlags and ffMethod=0 then GetSelfObject:=nil
 else GetSelfObject:=FObject2x2
end;

procedure TFuncObject.SetPersistant;
begin
 F.FuncFlags:=F.FuncFlags or ffPersistant
end;

function TFuncObject.ParsDefine:boolean;
begin
 ParsDefine:=CurCell=F.NPars
end;

procedure TFuncObject.PushObjInstance(Obj:pointer);
begin
 FObject2x2:=PUserObject(Obj)
end;

function TFuncObject.Register(Hash:PTermHash):boolean;
{ ॣ 㭪 ( ⮤!)   }
var H:PHashCell;
begin
 Register:=False;
 If CurCell<>F.NPars then exit;
 GetHashKey(Name); { - - }
 If Hash^.Search(Name,True,AllMask,H) then exit; { ⠪  㦥  }
 H^.HVal:=HFunc;
 { - ⨯ -.    Register, ..  .⮤ ⨯ 㤥 㣮 }
 case GetFuncType of
  ffFloatFunc: HFunc^.TermType:=opUserFunc;
  ffStrFunc: begin
   HFunc^.TermType:=opStringFunc;
  end;
  ffProc: HFunc^.TermType:=opUserProc;
 end;
 H^.TermType:=HFunc^.TermType;
 Register:=True
end;

function TFuncObject.GetFuncDef:PFunction;
begin
 GetFuncDef:=@F { ⥫ - }
end;

function TFuncObject.FunctionName:string;
begin
 FunctionName:=Name
end;

constructor TUserProc.Init(const AName:TermString; ArgCount:word);
var i:integer;
begin
 Inherited Init;
 If ArgCount>MaxFuncPars then ArgCount:=MaxFuncPars;
 with F do begin
  NPars:=ArgCount; MinFactArgs:=ArgCount;
 end;
 Name:=UpperCase(AName);
 HFunc^.Name:=Name;
 GetMem(Hashes,SizeOf(THashCell)*ArgCount);
 CurCell:=0;
 For i:=1 to ArgCount do F.Pars[i].Hash:=@Hashes^[i];
end;

function TUserProc.GetFuncType:word;
begin
 GetFuncType:=ffProc
end;

function TUserProc.InsertArgument(IsVar,NotSimp:boolean; t1,t2:word):boolean;
{ IsVar=True ᫨  뫪
  NotSimp=True ᫨ ffSimpleIfAllConst ᥣ 㡨
  t1 - ⨯  IsVar=True, t2 - ⨯  IsVar=False }
begin
 Inc(CurCell);
 If CurCell<=F.NPars then begin
  If IsVar then begin {  뫪 }
   t1:=t2;
   F.FuncFlags:=F.FuncFlags and not ffSimpleIfAllConst;
   Inc(F.NParVars)
  end
  else
   If NotSimp then F.FuncFlags:=F.FuncFlags and not ffSimpleIfAllConst;
  F.Pars[CurCell].TermType:=t1;
  InsertArgument:=True
 end
 else InsertArgument:=False
end;

function TUserProc.InsertFloatPar(IsVar:boolean):PFloat;
begin
 If InsertArgument(IsVar,False,opFUknown,opFPar) then InsertFloatPar:=@Hashes^[CurCell].ValueF
 else InsertFloatPar:=nil
end;

function TUserProc.InsertStrPar(IsVar:boolean):PText;
var P:PText;
begin
 If InsertArgument(IsVar,False,opSUknown,opSPar) then begin
  New(P);
  Hashes^[CurCell].ValueP:=P;
  InsertStrPar:=P
 end
 else InsertStrPar:=nil
end;

function TUserProc.InsertArray(What:word):Ppointer;
Var P:PStructDef;
begin
 If InsertArgument(False,True,What,0) then begin
  New(P);
  Hashes^[CurCell].HData:=P;
  InsertArray:=@P^.Data; { ^PMatrix }
 end
 else InsertArray:=nil
end;

function TUserProc.InsertUserTypePar(TypeId:TUserVarType; IsVar:boolean):PFloat;
var i:integer;
begin
 If InsertArgument(IsVar,True,opUserVar,opUserPar) then begin
  Hashes^[CurCell].What:=TypeId;
  InsertUserTypePar:=@Hashes^[CurCell].ValueF
 end
 else InsertUserTypePar:=nil
end;

function TUserProc.InsertObjectRefPar(Obj2x2:P2x2Object; IsVar:boolean):Ppointer;
var i:integer; P:PUserObject;
begin
 If InsertArgument(IsVar,True,opObjectRef,opObjectRef) then begin
  If IsVar then i:=utfByPar else i:=0;
  F.Pars[CurCell].UTFlag:=i;
  with Hashes^[CurCell] do begin
   HData:=Obj2x2;
   ValueP:=pointer(Obj2x2);
   What:=Obj2x2^.ObjId;
   InsertObjectRefPar:=@HData
  end;
 end
 else InsertObjectRefPar:=nil
end;

function TUserProc.InsertObjectPar(Obj2x2:P2x2Object; IsVar:boolean):PUserObject;
var i:integer; P:PUserObject;
begin
 If InsertArgument(IsVar,True,opObject,opObject) then begin
  If IsVar then i:=utfByPar else i:=0;
  F.Pars[CurCell].UTFlag:=i;
  P:=CreateObjInstance(Obj2x2); { ᮧ  ꥪ }
  with Hashes^[CurCell] do begin
   HData:=P;
   What:=Obj2x2^.ObjId;
   ValueP:=pointer(Obj2x2)
  end;
  InsertObjectPar:=P
 end
 else InsertObjectPar:=nil
end;

function TUserProc.InsertAnyObjectPar:Ppointer;
begin
 InsertAnyObjectPar:=InsertObjectRefPar(User2x2TObject,False)
end;

function TUserProc.InsertObjectTypePar:Ppointer;
begin
 If InsertArgument(False,True,opObjectType,opObjectType) then
  InsertObjectTypePar:=@Hashes^[CurCell].HData
 else InsertObjectTypePar:=nil
end;

function TUserProc.InsertArrayPar:Ppointer;
begin
 InsertArrayPar:=InsertArray(opArrayVar)
end;

function TUserProc.InsertStrArrayPar:Ppointer;
begin
 InsertStrArrayPar:=InsertArray(opStrArrVar)
end;

function TUserProc.InsertAnyArrayPar:Ppointer;
begin
 InsertAnyArrayPar:=InsertArray(opAnyArrVar)
end;

function TUserProc.InsertPolinomPar:Ppointer;
begin
 InsertPolinomPar:=InsertArray(opPolinom)
end;

procedure TUserProc.InsertSubrPar(const ParamTypes:string; What:word);
var i,Len:integer; ParFunc:PFunction;
begin
 If InsertArgument(False,True,What,0) then begin
  New(ParFunc);
  FillChar(ParFunc^,SizeOf(TFunction),0);
  Len:=MinI(Length(ParamTypes),MaxFuncPars);
  ParFunc^.NPars:=Len;
  with Hashes^[CurCell] do begin
   HData:=ParFunc;
   What:=0 { ਧ,    ⮤ }
  end;
  {  맮 襩 -, --- ParFunc^ 㤥  
    ᮤন TFunction 䠪. - }
  For i:=1 to Len do
   With ParFunc^.Pars[i] do
    case ParamTypes[i] of
     '@': TermType:=opFPar;
     'A','a': TermType:=opArrayVar;
     's': TermType:=opSUknown;
     {'O': TermType:=opPolinom;}
     else {'*'} TermType:=opFUknown;
    end;
 end
end;

procedure TUserProc.InsertFuncPar(const ParamTypes:string);
begin
 InsertSubrPar(ParamTypes,opUserFunc)
end;

procedure TUserProc.InsertProcPar(const ParamTypes:string);
begin
 InsertSubrPar(ParamTypes,opUserProc)
end;

procedure TUserProc.InsertMultiPar;
begin
 If InsertArgument(False,False,opMultiVar,0) then
  Hashes^[CurCell].HData:=New(PCollection,Init(32,16));
end;

function TUserProc.NumOfMultiArgs(ParNum:integer):integer;
{ ParNum 㬥  1 }
begin
 If (ParNum>0) and (ParNum<=F.NPars) and (F.Pars[ParNum].TermType=opMultiVar) then
  NumOfMultiArgs:=PCollection(Hashes^[ParNum].HData)^.Count
 else NumOfMultiArgs:=0
end;

procedure TUserProc.MultiArgDesc(ParNum,ArgNum:integer; var ArgType:TMultiExprType;
 var AByValue:boolean);
{ ParNum,ArgNum 㬥  1 }
begin
 If (ArgNum>0) and (ArgNum<=NumOfMultiArgs(ParNum)) then
  with PMultiFact(PCollection(Hashes^[ParNum].HData)^.At(ArgNum-1))^ do begin
   ArgType:=What;
   AByValue:=ByValue
  end
end;

function TUserProc.MultiArgValue(ParNum,ArgNum:integer):pointer;
{ ParNum,ArgNum 㬥  1 }
begin
 If (ArgNum>0) and (ArgNum<=NumOfMultiArgs(ParNum)) then
  with PMultiFact(PCollection(Hashes^[ParNum].HData)^.At(ArgNum-1))^ do
   MultiArgValue:=Value
 else MultiArgValue:=nil
end;

procedure TUserProc.ClearMultiList(ParNum:integer);
{ 頥 ⥪騩 ᯨ᮪ 䠪᪨ ⨯ࠬ஢; - ⮫쪮 ஬ }
var i:integer;
begin
 with Hashes^[ParNum] do
  with PCollection(HData)^ do begin
   For i:=0 to Count-1 do Dispose(PMultiFact(At(i)));
   DeleteAll
  end
end;

function TUserProc.CallParFunc(ParNum:word; var Data):Float;
type PArr=array[1..MaxFuncPars] of pointer;
var i:integer; ParFunc:PFunction;
begin
 If (ParNum>F.NPars) or not ((F.Pars[ParNum].TermType=opUserFunc) or
  (F.Pars[ParNum].TermType=opUserProc)) then exit;
 ParFunc:=Hashes^[ParNum].HData;
 { । - - । 맮 --- }
 { । 맮 襩 -  ParFunc^.Pars[..] 㦥 饭 
   - 䠪. --- }
 For i:=1 to ParFunc^.NPars do
  with ParFunc^.Pars[i] do
   case TermType of
    {   䠪. - । - Float }
    opSPar,opFUknown: Hash^.ValueF:=PFloat(PArr(Data)[i])^;
    opSPar,opSUknown: Hash^.ValueP^:=PText(PArr(Data)[i])^;
    {  TStructDef 䠪. - । PMatrix }
    opArrayVar{,opPolinom}: PStructDef(Hash^.HData)^.Data:=PArr(Data)[i];
   end;

 { 뢠 - }
 PCalcer(ParFunc^.FuncCalc)^.Evaluate;

 {  --뫮 頥 - }
 For i:=1 to ParFunc^.NPars do
  with ParFunc^.Pars[i] do
   If TermType=opSPar then PFloat(PArr(Data)[i])^:=Hash^.ValueF;

 { 頥 १- }
 If Hashes^[ParNum].TermType=opUserFunc then CallParFunc:=ParFunc^.FuncName^.ValueF
 else CallParFunc:=0
end;

destructor TUserProc.Done;
var i:word;
begin
 For i:=1 to CurCell {F.NPars} do With F do
  Case Pars[i].TermType of
   opSPar,opSUknown: Dispose(PText(Hashes^[i].ValueP));
   opArrayVar..opStrArrVar,opAnyArrVar: Dispose(PStructDef(Hashes^[i].HData));
   opUserFunc,opUserProc: Dispose(PFunction(Hashes^[i].HData));
   opMultiVar:begin
    ClearMultiList(i);
    Dispose(PCollection(Hashes^[i].HData),Done);
   end;
   opObject: Dispose(PUserObject(Hashes^[i].HData),Done);
  end;
 FreeMem(Hashes,SizeOf(THashCell)*F.NPars);
 Inherited Done
end;

constructor TUserFunc.Init(const AName:TermString; ArgCount:byte; Options:TFuncOptions);
begin
 ArgCount:=MinI(ArgCount,MaxFuncPars);
 Inherited Init(AName,ArgCount);
 FactArgCount:=ArgCount;
 with F do begin
  If foAsProperty in Options then FuncFlags:=FuncFlags or ffProperty;
  If foSimplified in Options then FuncFlags:=FuncFlags or ffSimpleIfAllConst
 end
end;

function TUserFunc.GetFuncType:word;
begin
 GetFuncType:=ffFloatFunc
end;

procedure TUserFunc.SetMinArgCount(MinCount:integer);
begin
 If (MinCount>0) and (MinCount<=F.NPars) then F.MinFactArgs:=MinCount
end;

function TUserFunc.Calculate:PFloat;
begin
 Evaluate;
 Calculate:=@HFunc^.ValueF
end;

procedure TUserFunc.SetResult(Res:PFloat);
begin
 HFunc^.ValueF:=Res^ { १- - -     }
end;

procedure TUserFunc.AssignValue(Value:pointer);
begin end;

procedure TUserFunc.AssignResult(Res:pointer);
begin end;

function TUserStrFunc.GetFuncType:word;
begin
 GetFuncType:=ffStrFunc
end;

procedure TUserStrFunc.SetResult(Res:PText);
begin
 HFunc^.ValueP^:=Res^ { १- - -     }
end;

function TUserStrFunc.Calculate:PFloat;
begin
 Evaluate;
 Calculate:=pointer(HFunc^.ValueP)
end;

procedure TObjFieldColl.FreeItem(Item:pointer);
var P:PFuncObject; F:PFunction;
begin
 with PObjFieldDef(Item)^ do
  case FType of
   opParFunc,opParStrFunc,opParProc,opUserFunc,opStringFunc,opUserProc:
    If Data<>nil then begin
     F:=PFunction(Data^.HData);
     If F^.FuncFlags and ffPersistant=0 then begin
      P:=PFuncObject(F^.FuncCalc);
      If P<>nil then Dispose(P,Done);
     end
    end;
  end;
 Dispose(PObjFieldDef(Item))
end;

function TObjFieldColl.FindByNum(SNum:integer):PObjFieldDef;
 function Match(Item:pointer):boolean;far;
 begin
  Match:=PObjFieldDef(Item)^.Num=SNum
 end;
begin
 FindByNum:=PObjFieldDef(FirstThat(@Match));
end;

function TObjFieldColl.FindByName(const IdName:string):integer;
var P:PObjFieldDef;
 function Match(Item:pointer):boolean;far;
 begin
  Match:=PObjFieldDef(Item)^.FName=IdName
 end;
begin
 P:=PObjFieldDef(FirstThat(@Match));
 If P=nil then FindByName:=0 else FindByName:=P^.Num;
end;

procedure T2x2Object.SetWhoCreate(WC:pointer);
begin
 WhoCreate:=WC
end;

destructor T2x2Object.Done;
begin
 Dispose(Fields,Done);
 If WhoCreate<>nil then PCompilator(WhoCreate)^.FreeObjId(ObjId);
 Inherited Done;
end;

constructor T2x2Object.Init(ObjName:TermString; AObjId:TObjVarType; InheritObj:P2x2Object);
begin
 Inherited Init;
 If (InheritObj=nil) and (AObjId<>opObjType3) then InheritObj:=User2x2TObject;
 If InheritObj<>nil then begin
  FieldCnt:=InheritObj^.GetFieldCount;
  CurMethod:=-InheritObj^.GetMethodCount;
  MethodCnt:=InheritObj^.GetMethodCount;
  FInitCreated:=InheritObj^.FInitCreated;
 end
 else begin
  CurMethod:=0; FieldCnt:=0; MethodCnt:=0;
  FInitCreated:=False;
 end;
 InheritObject:=InheritObj;
 OnCreate2x2Object:=nil; OnDestroy:=nil;
 Operators:=[]; Functions:=[];
 ProtectedLock:=True;
 Name:=UpperCase(ObjName);
 ObjId:=AObjId;
 WhoCreate:=nil;
 Fields:=New(PObjFieldColl,Init(32,16));
end;

function T2x2Object.FindByNum(SNum:integer):PObjFieldDef;
{  ⥫    .
  SNum>0 - ६; SNum<0 - ⮤ }
var P:PObjFieldDef;
begin
 P:=Fields^.FindByNum(SNum);
 If (P=nil) and (InheritObject<>nil) then P:=InheritObject^.FindByNum(SNum);
 FindByNum:=P
end;

function T2x2Object.FindByName(const IdName:string):integer;
{ ।     , IdName -  孥 ॣ! }
var i:integer;
begin
 i:=Fields^.FindByName(IdName);
 If i=0 then begin
  If InheritObject<>nil then i:=InheritObject^.FindByName(IdName);
 end;
 FindByName:=i
end;

function T2x2Object.FindField(IdName:string):integer;
{ ।      }
begin
 FindField:=FindByName(UpperCase(IdName));
end;

function T2x2Object.GetFieldCount:integer;
begin
 GetFieldCount:=FieldCnt;
end;

function T2x2Object.GetMethodCount:integer;
begin
 GetMethodCount:=MethodCnt;
end;

function T2x2Object.GetFieldDef(Num:integer):PObjFieldDef;
{ 頥 ⥫     }
var i:integer;
begin
 i:=FieldCnt-Fields^.Count; { ᫮   த⥫ }
 If Num>i then GetFieldDef:=Fields^.At(Num-i-1)
 else GetFieldDef:=InheritObject^.GetFieldDef(Num)
end;

procedure T2x2Object.SetOnCreate(CreateFunc:TOnCreate2x2Object);
begin
 OnCreate2x2Object:=CreateFunc;
end;

procedure T2x2Object.SetOnCalcFunc(CalcFunc:TOnCalcFunc);
begin
 OnCalcFunc:=CalcFunc
end;

procedure T2x2Object.SetOnCalcOperator(CalcOperator:TOnCalcOperator);
begin
 OnCalcOperator:=CalcOperator
end;

procedure T2x2Object.SetOnDestroy(DestroyFunc:TOnDestroyObject);
begin
 OnDestroy:=DestroyFunc
end;

function T2x2Object.IsDefOperator(AOperator:TMOOperations):boolean;
begin
 IsDefOperator:=AOperator in Operators
end;

function T2x2Object.IsDefFunction(AFunction:TUnar):boolean;
begin
 IsDefFunction:=AFunction in Functions
end;

procedure T2x2Object.EnableOperator(AOperators:TOperations);
begin
 Operators:=AOperators
end;

function T2x2Object.GetOwnFldDefCnt:integer;
begin
 GetOwnFldDefCnt:=Fields^.Count
end;

function T2x2Object.GetOwnFldDef(Num:integer):PObjFieldDef;
begin
 GetOwnFldDef:=Fields^.At(Num)
end;

procedure T2x2Object.EnableFunction(AFunctions:TUnarFuncs);
begin
 Functions:=AFunctions
end;

procedure T2x2Object.DefineArray(FieldNo:integer; Lines,Cols:integer);
var P:PObjFieldDef;
begin
 If FieldNo<=0 then exit;
 { ࠧ୮  ⮫쪮    ꥪ,    㭠᫥ }
 P:=Fields^.FindByNum(FieldNo);
 If Cols<=0 then Cols:=1;
 If (P<>nil) and ((P^.FType=opArrayVar) or (P^.FType=opStrArrVar)) then
  With P^ do begin
   ACols:=Cols; ALines:=Lines
  end
end;

function T2x2Object.AddField(const FieldName:Termstring; FieldType:TObjFieldType;
 FldOption:TFldOption):boolean;
begin
 AddField:=AddFieldPrim(FieldName,FieldType,nil,FldOption)
end;

function T2x2Object.AddObjectRefField(const FieldName:Termstring; ObjDef:P2x2Object;
 FldOption:TFldOption):boolean;
begin
 AddObjectRefField:=AddFieldPrim(FieldName,dctObjRef,ObjDef,FldOption)
end;

function T2x2Object.AddObjectField(const FieldName:Termstring; ObjDef:P2x2Object;
 FldOption:TFldOption):boolean;
begin
 AddObjectField:=AddFieldPrim(FieldName,dctObject,ObjDef,FldOption)
end;

function T2x2Object.AddFieldPrim(FieldName:Termstring; FieldType:TObjFieldType; AData:pointer;
 FldOption:TFldOption):boolean;
const
 FT:array[dctFloat..dctStrArray] of OpsType=(opFPar,opSPar,opAnyArrVar,opArrayVar,opStrArrVar);
var P:PObjFieldDef; Err:integer; X:word;
begin
 AddFieldPrim:=False;
 If FieldType=dctAnyArray then exit;
 ValidName(FieldName,Err,X);
 If Err<>0 then exit;
 If FindByName(FieldName)<>0 then exit; { ⠪  㦥  }
 If FieldType=dctObject then
  If P2x2Object(AData)^.ExistObjField(@Self) then exit;
 Inc(FieldCnt);
 New(P);
 with P^ do begin
  FName:=FieldName;
  Num:=FieldCnt;
  Data:=AData;
  If offProtected in FldOption then FldFlags:=off_Protected else FldFlags:=0;
  If offReadOnly in FldOption then FldFlags:=FldFlags or off_ReadOnly;
  case FieldType of
   dctFloat..dctString: FType:=FT[FieldType];
   dctArray..dctStrArray: begin
    FType:=FT[FieldType]; ACols:=0; Alines:=0
   end;
   dctUserType1..dctUserType2: begin
    FType:=opUserVar; P^.UType:=FieldType;
   end;
   dctObject: FType:=opObject;
   dctObjRef: FType:=opObjectRef;
  end;
 end;
 Fields^.Insert(P);

 If not FInitCreated then begin
  AddMethod(ObjInitMethod,[]);
  FInitCreated:=True;
 end;
 AddFieldPrim:=True;
end;

function T2x2Object.ExistObjField(O:P2x2Object):boolean;
{   -ꥪ  ⨯, ࠢ  O }
var P:PObjFieldDef; i:integer;
begin
 ExistObjField:=True;
 For i:=1 to FieldCnt do begin
  P:=FindByNum(i);
  If P^.FType=dctObject then begin
   If P^.Data=pointer(O) then exit;
   If P2x2Object(P^.Data)^.ExistObjField(O) then exit
  end
 end;
 ExistObjField:=False
end;

function T2x2Object.AddMethodPrim(MethDef:PFunction; const MName:TermString;
 MethodOption:TFldOption):integer;
const
 MT:array[TMethodType] of OpsType=(opUserFunc,opStringFunc,opUserProc);
 MT1:array[TMethodType] of OpsType=(opParFunc,opParStrFunc,opParProc);
var P:PObjFieldDef; i,j:integer; F,PF:PFunction; w:word; MethodType:TMethodType;
    IsVirtual:boolean;
begin
 AddMethodPrim:=-1;
 IsVirtual:=offVirtual in MethodOption;
 F:=MethDef;
 If F^.FuncFlags and ffAsMethodEnable=0 then exit;
 { ७ ᠭ - ⮤    }
 w:=F^.FuncFlags and (ffFloatFunc or ffStrFunc or ffProc);
 case w of
  ffFloatFunc: MethodType:=mtFloatFunc;
  ffStrFunc: MethodType:=mtStrFunc;
  ffProc: MethodType:=mtProc
 end;

 If Fields^.FindByName(MName)<>0 then exit; { 㡫஢ - }
 If IsVirtual then F^.FuncFlags:=F^.FuncFlags or ffVirtual;

 i:=FindByName(MName);
 If i>0 then exit; { ࠭  ⠪  뫠 ᠭ ६ }
 If (i<>0) then begin
  P:=FindByNum(i);
  PF:=PFunction(P^.Data^.HData);
  If IsVirtual then begin
   { ஢ਬ,  ⮤ ⮬ ⮦ 㠫   ⠪  㬥 }
   If PF^.FuncFlags and ffVirtual=0 then begin
    AddMethodPrim:=teInhNotVirtual; exit
   end;
   If not PFuncObject(PF^.FuncCalc)^.Equal(F) then begin
    AddMethodPrim:=teMethodNotEqual; exit
   end;
  end
  else
   If PF^.FuncFlags and ffVirtual<>0 then begin
    AddMethodPrim:=teVirtualExpected; exit
   end;
 end;
 If i=0 then begin { ⮤  ⠪    }
  Inc(MethodCnt);
  Dec(CurMethod);
  j:=CurMethod
 end
 else j:=i;
 New(P);
 with P^ do begin
  Num:=j;
  FName:=MName;
  If offProtected in MethodOption then FldFlags:=off_Protected else FldFlags:=0;
  If IsVirtual then FType:=MT1[MethodType] else FType:=MT[MethodType];
  F^.FuncFlags:=(F^.FuncFlags or ffMethod) and not ffSimpleIfAllConst;
  With MethDef^ do begin
   Data:=FuncName;
   FuncName^.What:=Method_Flag;
   Data^.TermType:=FType;
  end
 end;
 Fields^.Insert(P);
 AddMethodPrim:=0;
end;

function T2x2Object.AddMethod(MethodCalcer:P2x2Function; MethodOption:TFldOption):integer;
begin
 If not MethodCalcer^.ParsDefine then AddMethod:=-1
 else
  AddMethod:=AddMethodPrim(MethodCalcer^.GetFuncDef,MethodCalcer^.FunctionName,MethodOption);
end;

function T2x2Object.ObjectIsParent(AObjId:TObjVarType):boolean;
{ ࠢ    AObjId । ⥪饣 ꥪ }
var b:boolean;
begin
 b:=ObjId=AObjId;
 If not b and (InheritObject<>nil) then b:=InheritObject^.ObjectIsParent(AObjId);
 ObjectIsParent:=b
end;

function T2x2Object.FindMethod(MethodNum:integer):PFunction;
{ MethodNum<0 }
var P:PObjFieldDef;
begin
 P:=FindByNum(MethodNum);
 If P<>nil then FindMethod:=PFunction(P^.Data^.HData) else FindMethod:=nil
end;

procedure T2x2Object.ProtectFields(On:boolean);
begin
 ProtectedLock:=On
end;

function T2x2Object.GetProtectSwitch:boolean;
begin
 GetProtectSwitch:=ProtectedLock
end;

function T2x2Object.FindIdent(const IdName:TermString; var FNum:integer; var P:PObjFieldDef):integer;
begin
 FNum:=FindByName(IdName);
 If FNum<>0 then begin { /⮤ }
  P:=FindByNum(FNum);
  If (P^.FldFlags and off_Protected<>0) and ProtectedLock then begin
   FindIdent:=oitUknown; exit
  end;
  If FNum>0 then begin {  }
   case P^.FType of
    opFPar,opUserVar,opSPar,opArrayVar,opStrArrVar: FindIdent:=oitField;
    opObject: FindIdent:=oitObject;
    opObjectRef: FindIdent:=oitRefObject;
   end
  end
  else FindIdent:=oitMethod
 end
 else FindIdent:=oitUknown
end;

function TUserObject.GetFieldHash(FNum:integer):PHashCell;
begin
 GetFieldHash:=Hashes^[FNum]
end;

destructor TUserObject.Done;
var i:integer; H:PHashCell; W:P2x2Function;
begin
 W:=FindVirtualMethod(DestroyMethodNum)^.FuncCalc;
 W^.PushObjInstance(@Self);
 W^.Evaluate;

 with FObjDef^ do
  If Assigned(OnDestroy) then OnDestroy(@Self);

 For i:=1 to FFieldCnt do
  With Hashes^[i]^ do begin
   case TermType of
    opSPar: Dispose(PText(ValueP));
    opArrayVar,opStrArrVar: begin
     with PStructDef(HData)^ do
      If Data<>nil then Dispose(PMatrix(Data),Done);
     Dispose(PStructDef(HData));
    end;
    opObject: Dispose(PUserObject(HData),Done);
   end;
   Dispose(Hashes^[i]);
  end;
 FreeMem(Hashes,(FFieldCnt+FMethodCnt)*SizeOf(pointer));
 Inherited Done;
end;

constructor TUserObject.Init(Obj2x2:P2x2Object);
var P:PObjFieldDef; i,k:integer; Q:PStructDef; W:P2x2Function; Fn:PFunction;
begin
 Inherited Init;
 ObjTag:=0;
 UserData:=nil;
 AutoCreated:=True;
 FObjDef:=Obj2x2;
 FFieldCnt:=Obj2x2^.GetFieldCount;
 FMethodCnt:=Obj2x2^.GetMethodCount;
 GetMem(Hashes,(FFieldCnt+FMethodCnt)*SizeOf(pointer));
 k:=FFieldCnt;
 { -  ६ }
 For i:=1 to k do begin
  New(Hashes^[i]);
  P:=Obj2x2^.FindByNum(i);
  with Hashes^[i]^ do begin
   HData:=nil;
   If P<>nil then begin
    TermType:=P^.FType;
    If P^.FldFlags and off_ReadOnly=0 then HFlags:=0 else HFlags:=off_ReadOnly;
    case TermType of
     opSPar: New(PText(ValueP));
     opArrayVar,opStrArrVar: begin
      New(Q);
      with P^ do
       If (ACols<>0) and (ALines<>0) then begin
        If TermType=opArrayVar then Q^.Data:=New(PHeapMatrixFG,Init(ALines,ACols))
        else Q^.Data:=New(PStrMatrix,Init(ALines,ACols))
       end
       else Q^.Data:=nil; { PMatrix }
      HData:=Q
     end;
     opUserVar: What:=P^.UType;
     opObject: begin
      What:=P2x2Object(P^.Data)^.ObjId;
      HData:=CreateObjInstance(P2x2Object(P^.Data));
     end;
     opObjectRef:begin
      What:=P2x2Object(P^.Data)^.ObjId;
      HData:=P^.Data
     end;
    end;
   end;
  end
 end;

 { - ⮤ }
 For i:=1 to FMethodCnt do begin
  P:=Obj2x2^.FindByNum(-i);
  Inc(k);
  Hashes^[k]:=P^.Data; {   । }
 end;
 { 뢠 ⮤ Create }
 Fn:=FindVirtualMethod(CreateMethodNum);
 If Fn^.FuncFlags and ffNotCreated<>0 then
  PCompilator(CurCompilator)^.AddCreateObj(@Self)
 else begin
  W:=Fn^.FuncCalc;
  If W<>nil then begin
   W^.PushObjInstance(@Self);
   W^.Evaluate;
  end
 end
end;

procedure TUserObject.CallCreate;
var W:P2x2Function;
begin
 W:=FindVirtualMethod(CreateMethodNum)^.FuncCalc;
 If W<>nil then begin
  W^.PushObjInstance(@Self);
  W^.Evaluate;
 end
end;

function TUserObject.ObjectIsParent(AObjId:TObjVarType):boolean;
begin
 ObjectIsParent:=FObjDef^.ObjectIsParent(AObjId)
end;

procedure TUserObject.PutField(FieldNo:integer; Var AValue);
{ ᢮ -   }
var P:PObjFieldDef;
begin
 P:=FObjDef^.FindByNum(FieldNo);
 If P<>nil then With Hashes^[FieldNo]^ do
  case P^.FType of
   opFPar,opUserVar: ValueF:=Float(AValue);
   opSPar: ValueP^:=string(AValue);
   opObject: PUserObject(HData)^.Assign(PUserObject(AValue));
   opObjectRef: HData:=PUserObject(AValue);
   opArrayVar,opStrArrVar:
    with PStructDef(HData)^ do
     If Data<>nil then PMatrix(Data)^.Assign(PMatrix(AValue))
  end
end;

procedure TUserObject.GetField(FieldNo:integer; Var AValue);
{ 饭 -   }
var P:PObjFieldDef;
begin
 P:=FObjDef^.FindByNum(FieldNo);
 If P<>nil then With Hashes^[FieldNo]^ do
  case P^.FType of
   opFPar,opUserVar: Float(AValue):=ValueF;
   opSPar: string(AValue):=ValueP^;
   opArrayVar,opStrArrVar: PMatrix(AValue):=PStructDef(HData)^.Data;
   opObject: PUserObject(AValue)^.AssignSmart(PUserObject(HData));
   opObjectRef: PUserObject(AValue):=HData;
  end
end;

procedure TUserObject.PutRawField(FieldNo:integer; AValue:pointer);
var P:PObjFieldDef;
begin
 P:=FObjDef^.FindByNum(FieldNo);
 If P<>nil then With Hashes^[FieldNo]^ do
  case P^.FType of
   opFPar,opUserVar: ValueF:=PFloat(AValue)^;
   opSPar: ValueP^:=Pstring(AValue)^;
   opObject: PUserObject(HData)^.Assign(PUserObject(AValue));
   opObjectRef: HData:=PUserObject(AValue);
   opArrayVar,opStrArrVar:
    with PStructDef(HData)^ do
     If Data<>nil then PMatrix(Data)^.Assign(PMatrix(AValue))
  end
end;

function TUserObject.GetRawField(FieldNo:integer):pointer;
var P:PObjFieldDef;
begin
 P:=FObjDef^.FindByNum(FieldNo);
 If P<>nil then With Hashes^[FieldNo]^ do
  case P^.FType of
   opFPar,opUserVar: GetRawField:=@ValueF;
   opSPar: GetRawField:=ValueP;
   opArrayVar,opStrArrVar: GetRawField:=PStructDef(HData)^.Data;
   opObject,opObjectRef: GetRawField:=HData;
  end
end;

function TUserObject.GetArrayRef(FieldNo:integer):PStructDef;
var P:PObjFieldDef;
begin
 P:=FObjDef^.FindByNum(FieldNo);
 If P<>nil then
  With Hashes^[FieldNo]^ do GetArrayRef:=PStructDef(HData);
end;

function TUserObject.GetObjectRef(FieldNo:integer):pointer;
var P:PObjFieldDef;
begin
 P:=FObjDef^.FindByNum(FieldNo);
 If P<>nil then
  With Hashes^[FieldNo]^ do GetObjectRef:=@HData;
end;

function TUserObject.GetMethod(MethodName:TermString):P2x2Function;
{ 頥 ⥪騩 ᫨⥫ .⮤ ( ⮬ 䨧,
  ..  .⮤ ᫨⥫   ⥪饣 ᮤন  }
var i:integer; H:PHashCell;
begin
 MethodName:=UpperCase(MethodName);
 i:=FObjDef^.FindByName(MethodName);
 If i<0 then GetMethod:=P2x2Function(FindVirtualMethod(-i)^.FuncCalc)
 else GetMethod:=nil
end;

function TUserObject.GetInheritMethod(MethodName:TermString):P2x2Function;
{ 頥 . ⮤  ꥪ-।.  㠫 -  "த"
  ⮤ ।    ⥫ ꥪ (   );  ᪨ -
   ⮤ । }
var i:integer; P:PObjFieldDef; O:P2x2Object;
begin
 GetInheritMethod:=nil;
 O:=FObjDef^.InheritObject;
 If O<>nil then begin
  MethodName:=UpperCase(MethodName);
  i:=O^.FindByName(MethodName);
  If i<0 then begin
   P:=O^.FindByNum(i);
   GetInheritMethod:=PFunction(P^.Data^.HData)^.FuncCalc
  end
 end
end;

function TUserObject.FindVirtualMethod(MethodNum:integer):PFunction;
begin
 FindVirtualMethod:=PFunction(Hashes^[FFieldCnt+MethodNum]^.HData)
end;

procedure TUserObject.Assign(SrcObj:PUserObject);
{ ᢮  ꥪ 祭 ꥪ SrcObj. SrcObj / ⠪ 
  ⨯,    ꥪ,  /  ⮬ }
var i:integer;
begin
 For i:=1 to FFieldCnt do PutRawField(i,SrcObj^.GetRawField(i));
end;

procedure TUserObject.AssignBackward(SrcObj:PUserObject);
{ ᢮  ꥪ 祭 ꥪ SrcObj. SrcObj / ⠪ 
  ⨯,    ꥪ,  /  । }
var i:integer;
begin
 For i:=1 to SrcObj^.FFieldCnt do PutRawField(i,SrcObj^.GetRawField(i))
end;

procedure TUserObject.AssignSmart(SrcObj:PUserObject);
{ ᢮  ꥪ 祭 ꥪ SrcObj }
begin
 If ObjectIsParent(SrcObj^.GetObjDef^.ObjId) then AssignBackward(SrcObj)
 else Assign(SrcObj)
end;

function TUserObject.GetObjDef:P2x2Object;
begin
 GetObjDef:=FObjDef
end;

procedure TUserObject.AutoCreatedOff;
begin
 AutoCreated:=False
end;

function CreateObjInstance(ObjDef:P2x2Object):PUserObject;
{ ᮧ  ꥪ  ⨯ ObjDef }
begin
 With ObjDef^ do
  If @OnCreate2x2Object<>nil then CreateObjInstance:=OnCreate2x2Object(ObjDef)
  else CreateObjInstance:=New(PUserObject,Init(ObjDef))
end;

procedure TInitProc.Evaluate;
var i,j:integer; ArgType:TMultiExprType; AByValue:boolean; P:PObjFieldDef;
    FObjDef:P2x2Object; Q:PUserObject; k:TMultiExprType;
begin
 Q:=PUserObject(GetSelfObject);
 FObjDef:=Q^.GetObjDef;
 j:=0;
 For i:=1 to NumOfMultiArgs(1) do begin
  Inc(j);
  MultiArgDesc(1,i,ArgType,AByValue);
  While True do begin
   P:=FObjDef^.FindByNum(j);
   If P=nil then exit;
   { ய⨬ Protected  ReadOnly  }
   If (P^.FldFlags and (off_Protected or off_ReadOnly)<>0) then Inc(j)
   else break
  end;
  { ஢塞, ᮢ  ⨯ }
  case P^.FType of
   opFPar: k:=wmpFloatMultiPar;
   opUserVar: k:=P^.UType;
   opSPar: k:=wmpStrMultiPar;
   opArrayVar,opStrArrVar: k:=wmpArrayMultiPar;
  end;
  If k<>ArgType then continue;
  Q^.PutRawField(j,MultiArgValue(1,i));
 end;
end;

procedure TGetObjTypeName.Evaluate;
var Tmp:TermString;
begin
 Tmp:=PUserObject(GetSelfObject)^.GetObjDef^.Name;
 SetResult(@Tmp)
end;

procedure TGetObjTypeId.Evaluate;
var Tmp:Float;
begin
 Tmp:=PUserObject(GetSelfObject)^.GetObjDef^.ObjId;
 SetResult(@Tmp)
end;

procedure TObjectFree.Evaluate;
var P:PUserObject;
begin
 P:=PUserObject(GetSelfObject);
 If (P<>nil) and not P^.AutoCreated then begin
  Dispose(P,Done)
 end
end;

procedure TCreateObject.Evaluate;
var P:PUserObject; Q:P2x2Object;
begin
 GetParValue(1,Q);
 P:=CreateObjInstance(Q); { ᮧ  ꥪ }
 P^.AutoCreated:=False;
 SetParValue(2,P);
end;

function CreateOCProc:PFuncObject;
var P:PCreateObject;
begin
 P:=New(PCreateObject,Init('CREATEOBJECT',2));
 with P^ do begin
  InsertObjectTypePar;
  InsertObjectRefPar(User2x2TObject,True)
 end;
 CreateOCProc:=P
end;

procedure InitUser;
begin
 ObjInitMethod:=New(PInitProc,Init('INIT',1));
 ObjInitMethod^.InsertMultiPar;
 ObjInitMethod^.SetPersistant;
end;

procedure CreateTObject(var TObj:P2x2Object);
var i:word;
begin
 i:=opObjType3;
 TObj:=New(P2x2Object,Init('TOBJECT',TObjFieldType(i),nil));
 ObjGetNameMethod:=New(PGetObjTypeName,Init('CLASSNAME',0,[]));
 ObjGetNameMethod^.SetPersistant;
 ObjGetIdMethod:=New(PGetObjTypeId,Init('CLASSID',0,[]));
 ObjGetIdMethod^.SetPersistant;
 ObjFreeMethod:=New(PObjectFree,Init('FREE',0));
 ObjFreeMethod^.SetPersistant;
 with TObj^ do begin
  AddMethod(ObjGetNameMethod,[]);
  AddMethod(ObjGetIdMethod,[]);
  AddMethod(ObjFreeMethod,[]);
  AddMethod(New(PUserProc,Init('CREATE',0)),[offVirtual]);
  AddMethod(New(PUserProc,Init('DESTROY',0)),[offVirtual]);
 end;
end;

procedure DoneUser;
begin
 Dispose(ObjInitMethod,Done);
 Dispose(ObjGetNameMethod,Done);
 Dispose(ObjGetIdMethod,Done);
 Dispose(ObjFreeMethod,Done);
end;

begin
 InitUser
end.
